using System;
using System.Collections;
using System.Configuration;
using System.Diagnostics;
using Syslog.Collector.Writer;
using Syslog.Config;

namespace Syslog.Collector
{
	/// <summary>
	/// Syslog Relay Controller 烋[eBOꂽ SyslogInfo o^ꂽ SyslogWriter ŕۑ܂B
	/// </summary>
	public class CollectorController : IDisposable
	{
        // SyslogWriter AZuݒ擾邽߂̃L[
        private const string ConfigSection = "syslogConfig/collector/modules";

        private Hashtable WriterList = new Hashtable();

        /// <summary>
        /// ftHgRXgN^B
        /// </summary>
        /// <exception cref="ModuleLoadingException">ISyslogWriter W[̃[hɃG[ꍇɃX[܂B</exception>
		public CollectorController()
		{
            // App.configǂݍŃAZuRNV擾
            AssemblyEntryCollection entries = (AssemblyEntryCollection) ConfigurationSettings.GetConfig(ConfigSection);

            // AZuo^ĂȂꍇ
            if (entries == null)
            {
                // ̃RNV쐬
                entries = new AssemblyEntryCollection(0);
            }

            // o^Ă郂W[
            foreach (AssemblyEntry entry in entries)
            {
                try
                {
                    // ISyslogWriter CX^XApp.config RtBO[Vnč쐬
                    ISyslogWriter writer = (ISyslogWriter) entry.CreateInstance(entry.Config);

                    Debug.Assert(writer != null, "SyslogC^̃[hɎs܂");

                    // ȂCX^X쐬łꍇ
                    if (writer != null)
                    {
                        // ݂̂߂̏
                        writer.Open();

                        // ISyslogWriter ̈ꗗXgɒǉ
                        WriterList[entry.ID] = writer;
                    }
                    else
                    {
                        // OX[
                        throw new ModuleLoadingException(String.Format("[{0}] Xi W[̃[hɎs܂", entry.ID));
                    }
                }
                catch (Exception e)
                {
                    Debug.Assert(false, "SyslogC^̓ǂݍ݂Ɏs܂", e.ToString());

                    Trace.WriteLine("SyslogC^̓ǂݍ݂Ɏs܂!", "Syslog.Collector.CollectorController");
                    Trace.Indent();
                    Trace.WriteLine(e, "Syslog.Collector.CollectorController");
                    Trace.Unindent();

                    // OX[
                    throw e;
                }
            }
		}

        /// <summary>
        /// SyslogInfo  ISyslogWriter ŏ܂B
        /// </summary>
        /// <param name="syslog">SyslogbZ[WJvZ SyslogInfoB</param>
        public void Collect(SyslogInfo syslog)
        {
            // ׂĂ ISyslogWriter ŏ
            foreach (ISyslogWriter writer in WriterList.Values)
            {
                try
                {
                    // Syslog
                    writer.WriteSyslog(syslog);
                }
                catch (Exception e)
                {
                    Debug.Assert(false, "bZ[W̃RNgɃG[܂", e.ToString());

                    Trace.WriteLine("bZ[W̃RNgɃG[܂!", "Syslog.Collector.CollectorController");
                    Trace.Indent();
                    Trace.WriteLine(e, "Syslog.Collector.CollectorController");
                    Trace.Unindent();
                }
            }
        }

        /// <summary>
        /// \[XJ܂B
        /// </summary>
        public void Close()
        {
            this.Dispose();
        }

        #region IDisposable o
        /// <summary>
        /// A}l[Wh\[XJ܂B
        /// </summary>
        public void Dispose()
        {
            // ׂĂ ISyslogWriter ܂
            foreach (ISyslogWriter writer in WriterList.Values)
            {
                try
                {
                    // C^N[Y
                    writer.Close();
                }
                catch (Exception e)
                {
                    Debug.Assert(false, "SyslogC^̃\[XɃG[܂", e.ToString());
                }
            }

            // ISyslogWriter XgNA
            WriterList.Clear();
        }
        #endregion
    }
}
