using System;
using System.Collections;
using System.ComponentModel;
using System.IO;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Xml;

namespace Syslog.Console.Controls.ConfigCreator
{
	public class TraceInputControl : Syslog.Console.Controls.ConfigCreator.ConfigInputControl
	{
        private System.Windows.Forms.Label SourceAddressFilterLabel;
        private System.Windows.Forms.ComboBox SourceAddressFilterCombo;
        private System.Windows.Forms.ComboBox PriorityFilterCombo;
        private System.Windows.Forms.Label PriorityFilterLabel;
        private System.Windows.Forms.CheckBox TraceEnabledCheck;
        private System.Windows.Forms.Label TraceEnabledLabel;
        private System.Windows.Forms.TextBox TraceFilePathTextBox;
        private System.Windows.Forms.Label TraceFilePathLabel;
        private System.Windows.Forms.Button FilePathDialogButton;
        private System.Windows.Forms.Label TraceLevelLabel;
        private System.Windows.Forms.SaveFileDialog TraceFilePathDialog;
        private System.Windows.Forms.ErrorProvider TraceErrorProvider;
		private System.ComponentModel.IContainer components = null;

		public TraceInputControl()
		{
			// ̌Ăяo Windows tH[ fUCiŕKvłB
			InitializeComponent();

            TraceFilePathTextBox.Text = Path.Combine(Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location), "Trace.log");
            TraceFilePathTextBox.SelectAll();

            // qRg[Iɍ쐬
            this.CreateControl();
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region fUCiŐꂽR[h
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
            this.SourceAddressFilterLabel = new System.Windows.Forms.Label();
            this.SourceAddressFilterCombo = new System.Windows.Forms.ComboBox();
            this.PriorityFilterCombo = new System.Windows.Forms.ComboBox();
            this.PriorityFilterLabel = new System.Windows.Forms.Label();
            this.TraceEnabledCheck = new System.Windows.Forms.CheckBox();
            this.TraceEnabledLabel = new System.Windows.Forms.Label();
            this.TraceFilePathTextBox = new System.Windows.Forms.TextBox();
            this.TraceFilePathLabel = new System.Windows.Forms.Label();
            this.FilePathDialogButton = new System.Windows.Forms.Button();
            this.TraceLevelLabel = new System.Windows.Forms.Label();
            this.TraceFilePathDialog = new System.Windows.Forms.SaveFileDialog();
            this.TraceErrorProvider = new System.Windows.Forms.ErrorProvider();
            this.InputGroup.SuspendLayout();
            // 
            // InputGroup
            // 
            this.InputGroup.Controls.Add(this.FilePathDialogButton);
            this.InputGroup.Controls.Add(this.TraceFilePathTextBox);
            this.InputGroup.Controls.Add(this.TraceEnabledCheck);
            this.InputGroup.Controls.Add(this.TraceEnabledLabel);
            this.InputGroup.Controls.Add(this.SourceAddressFilterCombo);
            this.InputGroup.Controls.Add(this.SourceAddressFilterLabel);
            this.InputGroup.Controls.Add(this.PriorityFilterCombo);
            this.InputGroup.Controls.Add(this.PriorityFilterLabel);
            this.InputGroup.Controls.Add(this.TraceFilePathLabel);
            this.InputGroup.Controls.Add(this.TraceLevelLabel);
            this.TraceErrorProvider.SetIconAlignment(this.InputGroup, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
            this.InputGroup.Name = "InputGroup";
            this.InputGroup.Text = "Trace";
            // 
            // SourceAddressFilterLabel
            // 
            this.SourceAddressFilterLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.SourceAddressFilterLabel.Enabled = false;
            this.SourceAddressFilterLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.SourceAddressFilterLabel.Location = new System.Drawing.Point(24, 192);
            this.SourceAddressFilterLabel.Name = "SourceAddressFilterLabel";
            this.SourceAddressFilterLabel.Size = new System.Drawing.Size(120, 22);
            this.SourceAddressFilterLabel.TabIndex = 6;
            this.SourceAddressFilterLabel.Text = "\[XAhX tB^:";
            // 
            // SourceAddressFilterCombo
            // 
            this.SourceAddressFilterCombo.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.SourceAddressFilterCombo.Enabled = false;
            this.SourceAddressFilterCombo.Items.AddRange(new object[] {
                                                                          "Off",
                                                                          "Error",
                                                                          "Warning",
                                                                          "Info",
                                                                          "Verbose"});
            this.SourceAddressFilterCombo.Location = new System.Drawing.Point(152, 192);
            this.SourceAddressFilterCombo.Name = "SourceAddressFilterCombo";
            this.SourceAddressFilterCombo.Size = new System.Drawing.Size(152, 22);
            this.SourceAddressFilterCombo.TabIndex = 7;
            // 
            // PriorityFilterCombo
            // 
            this.PriorityFilterCombo.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.PriorityFilterCombo.Enabled = false;
            this.PriorityFilterCombo.Items.AddRange(new object[] {
                                                                     "Off",
                                                                     "Error",
                                                                     "Warning",
                                                                     "Info",
                                                                     "Verbose"});
            this.PriorityFilterCombo.Location = new System.Drawing.Point(152, 224);
            this.PriorityFilterCombo.Name = "PriorityFilterCombo";
            this.PriorityFilterCombo.Size = new System.Drawing.Size(152, 22);
            this.PriorityFilterCombo.TabIndex = 9;
            // 
            // PriorityFilterLabel
            // 
            this.PriorityFilterLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.PriorityFilterLabel.Enabled = false;
            this.PriorityFilterLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.PriorityFilterLabel.Location = new System.Drawing.Point(24, 224);
            this.PriorityFilterLabel.Name = "PriorityFilterLabel";
            this.PriorityFilterLabel.Size = new System.Drawing.Size(120, 22);
            this.PriorityFilterLabel.TabIndex = 8;
            this.PriorityFilterLabel.Text = "vCIeB tB^:";
            // 
            // TraceEnabledCheck
            // 
            this.TraceEnabledCheck.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.TraceEnabledCheck.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.TraceEnabledCheck.Location = new System.Drawing.Point(152, 40);
            this.TraceEnabledCheck.Name = "TraceEnabledCheck";
            this.TraceEnabledCheck.Size = new System.Drawing.Size(160, 24);
            this.TraceEnabledCheck.TabIndex = 1;
            this.TraceEnabledCheck.Text = "g[Xo Lɂ";
            this.TraceEnabledCheck.TextAlign = System.Drawing.ContentAlignment.TopLeft;
            this.TraceEnabledCheck.CheckedChanged += new System.EventHandler(this.TraceEnabledCheck_CheckedChanged);
            // 
            // TraceEnabledLabel
            // 
            this.TraceEnabledLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.TraceEnabledLabel.Location = new System.Drawing.Point(24, 40);
            this.TraceEnabledLabel.Name = "TraceEnabledLabel";
            this.TraceEnabledLabel.Size = new System.Drawing.Size(112, 23);
            this.TraceEnabledLabel.TabIndex = 0;
            this.TraceEnabledLabel.Text = "g[Xo(&T):";
            // 
            // TraceFilePathTextBox
            // 
            this.TraceFilePathTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.TraceFilePathTextBox.Enabled = false;
            this.TraceErrorProvider.SetIconAlignment(this.TraceFilePathTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
            this.TraceFilePathTextBox.Location = new System.Drawing.Point(40, 96);
            this.TraceFilePathTextBox.Name = "TraceFilePathTextBox";
            this.TraceFilePathTextBox.Size = new System.Drawing.Size(296, 22);
            this.TraceFilePathTextBox.TabIndex = 3;
            this.TraceFilePathTextBox.Text = "";
            this.TraceFilePathTextBox.Validating += new System.ComponentModel.CancelEventHandler(this.TraceFilePathTextBox_Validating);
            // 
            // TraceFilePathLabel
            // 
            this.TraceFilePathLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.TraceFilePathLabel.Enabled = false;
            this.TraceFilePathLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.TraceFilePathLabel.Location = new System.Drawing.Point(24, 72);
            this.TraceFilePathLabel.Name = "TraceFilePathLabel";
            this.TraceFilePathLabel.Size = new System.Drawing.Size(208, 23);
            this.TraceFilePathLabel.TabIndex = 2;
            this.TraceFilePathLabel.Text = "g[Xo͐ t@C(&F):";
            // 
            // FilePathDialogButton
            // 
            this.FilePathDialogButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.FilePathDialogButton.Enabled = false;
            this.FilePathDialogButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.FilePathDialogButton.Location = new System.Drawing.Point(240, 128);
            this.FilePathDialogButton.Name = "FilePathDialogButton";
            this.FilePathDialogButton.Size = new System.Drawing.Size(93, 30);
            this.FilePathDialogButton.TabIndex = 4;
            this.FilePathDialogButton.Text = "Q(&R)";
            this.FilePathDialogButton.Click += new System.EventHandler(this.FilePathDialogButton_Click);
            // 
            // TraceLevelLabel
            // 
            this.TraceLevelLabel.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.TraceLevelLabel.Enabled = false;
            this.TraceLevelLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.TraceLevelLabel.Location = new System.Drawing.Point(24, 168);
            this.TraceLevelLabel.Name = "TraceLevelLabel";
            this.TraceLevelLabel.Size = new System.Drawing.Size(208, 23);
            this.TraceLevelLabel.TabIndex = 5;
            this.TraceLevelLabel.Text = "g[Xo̓x (tB^)";
            // 
            // TraceFilePathDialog
            // 
            this.TraceFilePathDialog.DefaultExt = "log";
            this.TraceFilePathDialog.Filter = "g[X Ot@C (*.log)|*.log|ׂẴt@C|*.*";
            // 
            // TraceErrorProvider
            // 
            this.TraceErrorProvider.ContainerControl = this;
            // 
            // TraceInputControl
            // 
            this.Name = "TraceInputControl";
            this.Load += new System.EventHandler(this.TraceInputControl_Load);
            this.InputGroup.ResumeLayout(false);

        }
        #endregion

        private void TraceInputControl_Load(object sender, System.EventArgs e)
        {
            SourceAddressFilterCombo.SelectedIndex = 0;
            PriorityFilterCombo.SelectedIndex = 0;
        }

        private void TraceEnabledCheck_CheckedChanged(object sender, System.EventArgs e)
        {
            foreach (Control control in InputGroup.Controls)
            {
                control.Enabled = TraceEnabledCheck.Checked;
            }

            TraceEnabledLabel.Enabled = true;
            TraceEnabledCheck.Enabled = true;
        }

        private void FilePathDialogButton_Click(object sender, System.EventArgs e)
        {
            if (DialogResult.OK == TraceFilePathDialog.ShowDialog())
            {
                TraceFilePathTextBox.Text = Path.GetFullPath(TraceFilePathDialog.FileName);
            }
        }

        private void TraceFilePathTextBox_Validating(object sender, System.ComponentModel.CancelEventArgs e)
        {
            string FilePath = TraceFilePathTextBox.Text.Trim();

            if (FilePath.Length > 0)
            {
                try
                {
                    Path.GetFullPath(FilePath);

                    TraceErrorProvider.SetError(TraceFilePathTextBox, String.Empty);
                }
                catch (Exception ex)
                {
                    TraceErrorProvider.SetError(TraceFilePathTextBox, ex.Message);

                    e.Cancel = true;
                }
            }
        }

        public override string ToString(string innerString)
        {
            const string ConfigElement = "system.diagnostics";

            if (!TraceEnabledCheck.Checked)
            {
                return String.Empty;
            }

            XmlDocument doc = new XmlDocument();
            XmlElement DiagnosticsElement = doc.CreateElement(ConfigElement);

            DiagnosticsElement.AppendChild(this.GetTracingSetting(doc));
            DiagnosticsElement.AppendChild(this.GetTraceSwitchesSetting(doc));
            doc.AppendChild(DiagnosticsElement);

            return doc.OuterXml;
        }

        private XmlNode GetTracingSetting(XmlDocument trace)
        {
            const string TextListenerName = "TextTraceListener";
            const string TextListenerType = "System.Diagnostics.TextWriterTraceListener";
            const string AutoFlushValue = "true";
            const string IndentedSizeValue = "4";

            const string ConfigElement = "trace";
            const string ConfigEntryElement = "listeners";
            const string ListenerEntryElement = "add";
            const string TraceAutoFlush = "autoflush";
            const string TraceIndentedSize = "indentsize";
            const string ListenerName = "name";
            const string ListenerType = "type";
            const string OutputPath = "initializeData";

            XmlElement TraceElement = trace.CreateElement(ConfigElement);

            XmlAttribute AutoFlushAttribute = trace.CreateAttribute(TraceAutoFlush);
            AutoFlushAttribute.Value = AutoFlushValue;

            XmlAttribute IndentedSizeAttribute = trace.CreateAttribute(TraceIndentedSize);
            IndentedSizeAttribute.Value = IndentedSizeValue;

            TraceElement.Attributes.Append(AutoFlushAttribute);
            TraceElement.Attributes.Append(IndentedSizeAttribute);

            XmlElement ListenersElement = trace.CreateElement(ConfigEntryElement);
            XmlElement TextTracerElement = trace.CreateElement(ListenerEntryElement);

            XmlAttribute ListenerNameAttribute = trace.CreateAttribute(ListenerName);
            ListenerNameAttribute.Value = TextListenerName;

            XmlAttribute ListenerTypeAttribute = trace.CreateAttribute(ListenerType);
            ListenerTypeAttribute.Value = TextListenerType;

            XmlAttribute OutputPathAttribute = trace.CreateAttribute(OutputPath);
            OutputPathAttribute.Value = TraceFilePathTextBox.Text;

            TextTracerElement.Attributes.Append(ListenerNameAttribute);
            TextTracerElement.Attributes.Append(ListenerTypeAttribute);
            TextTracerElement.Attributes.Append(OutputPathAttribute);

            ListenersElement.AppendChild(TextTracerElement);
            TraceElement.AppendChild(ListenersElement);

            return (XmlNode) TraceElement;
        }

        private XmlNode GetTraceSwitchesSetting(XmlDocument switches)
        {
            const string SourceAddressFilterSwitch = "SourceAddressFilterTraceSwitch";
            const string PriorityFilterSwitch = "PriorityFilterTraceSwitch";

            const string ConfigElement = "switches";
            const string ConfigEntry = "add";
            const string EntryName = "name";
            const string EntryValue = "value";

            XmlElement SwitchElement = switches.CreateElement(ConfigElement);
            XmlElement SrcAddrEntryElement = switches.CreateElement(ConfigEntry);
            XmlElement PriorityEntryElement = switches.CreateElement(ConfigEntry);

            XmlAttribute SrcAddrEntryNameAttribute = switches.CreateAttribute(EntryName);
            SrcAddrEntryNameAttribute.Value = SourceAddressFilterSwitch;
            XmlAttribute PriorityEntryNameAttribute = switches.CreateAttribute(EntryName);
            PriorityEntryNameAttribute.Value = PriorityFilterSwitch;

            XmlAttribute SrcAddrEntryValueAttribute = switches.CreateAttribute(EntryValue);
            SrcAddrEntryValueAttribute.Value = SourceAddressFilterCombo.SelectedIndex.ToString();
            XmlAttribute PriorityEntryValueAttribute = switches.CreateAttribute(EntryValue);
            PriorityEntryValueAttribute.Value = PriorityFilterCombo.SelectedIndex.ToString();

            SrcAddrEntryElement.Attributes.Append(SrcAddrEntryNameAttribute);
            SrcAddrEntryElement.Attributes.Append(SrcAddrEntryValueAttribute);
            PriorityEntryElement.Attributes.Append(PriorityEntryNameAttribute);
            PriorityEntryElement.Attributes.Append(PriorityEntryValueAttribute);

            SwitchElement.AppendChild(SrcAddrEntryElement);
            SwitchElement.AppendChild(PriorityEntryElement);

            return SwitchElement;
        }
	}
}

