using System;
using System.Collections;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Windows.Forms;
using System.Xml;

namespace Syslog.Console.Controls.ConfigCreator
{
	public class EventLogListenerInputControl : Syslog.Console.Controls.ConfigCreator.ConfigInputControl
	{
        private System.Windows.Forms.Label EventLogListenerLabel;
        private System.Windows.Forms.ComboBox EventLogListCombo;
        private System.Windows.Forms.Label PollingIntervalLabel;
        private System.Windows.Forms.NumericUpDown PollingIntervalUpDown;
		private System.ComponentModel.IContainer components = null;

		public EventLogListenerInputControl()
		{
			// ̌Ăяo Windows tH[ fUCiŕKvłB
            InitializeComponent();

            EventLogListCombo.DataSource = EventLog.GetEventLogs();
            EventLogListCombo.DisplayMember = "LogDisplayName";
            EventLogListCombo.ValueMember = "Log";

            // qRg[Iɍ쐬
            this.CreateControl();
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region fUCiŐꂽR[h
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
            this.EventLogListenerLabel = new System.Windows.Forms.Label();
            this.EventLogListCombo = new System.Windows.Forms.ComboBox();
            this.PollingIntervalLabel = new System.Windows.Forms.Label();
            this.PollingIntervalUpDown = new System.Windows.Forms.NumericUpDown();
            this.InputGroup.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.PollingIntervalUpDown)).BeginInit();
            // 
            // InputGroup
            // 
            this.InputGroup.Controls.Add(this.PollingIntervalUpDown);
            this.InputGroup.Controls.Add(this.EventLogListCombo);
            this.InputGroup.Controls.Add(this.EventLogListenerLabel);
            this.InputGroup.Controls.Add(this.PollingIntervalLabel);
            this.InputGroup.Name = "InputGroup";
            this.InputGroup.Text = "Simple EventLog Listener";
            // 
            // EventLogListenerLabel
            // 
            this.EventLogListenerLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.EventLogListenerLabel.Location = new System.Drawing.Point(24, 32);
            this.EventLogListenerLabel.Name = "EventLogListenerLabel";
            this.EventLogListenerLabel.Size = new System.Drawing.Size(152, 23);
            this.EventLogListenerLabel.TabIndex = 0;
            this.EventLogListenerLabel.Text = "ϊCxgO(&E):";
            // 
            // EventLogListCombo
            // 
            this.EventLogListCombo.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.EventLogListCombo.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.EventLogListCombo.Location = new System.Drawing.Point(184, 32);
            this.EventLogListCombo.Name = "EventLogListCombo";
            this.EventLogListCombo.Size = new System.Drawing.Size(152, 22);
            this.EventLogListCombo.TabIndex = 1;
            // 
            // PollingIntervalLabel
            // 
            this.PollingIntervalLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.PollingIntervalLabel.Location = new System.Drawing.Point(24, 64);
            this.PollingIntervalLabel.Name = "PollingIntervalLabel";
            this.PollingIntervalLabel.Size = new System.Drawing.Size(152, 23);
            this.PollingIntervalLabel.TabIndex = 2;
            this.PollingIntervalLabel.Text = "|[OԊu(ms) (&I):";
            // 
            // PollingIntervalUpDown
            // 
            this.PollingIntervalUpDown.Increment = new System.Decimal(new int[] {
                                                                                    1000,
                                                                                    0,
                                                                                    0,
                                                                                    0});
            this.PollingIntervalUpDown.Location = new System.Drawing.Point(184, 64);
            this.PollingIntervalUpDown.Maximum = new System.Decimal(new int[] {
                                                                                  600000,
                                                                                  0,
                                                                                  0,
                                                                                  0});
            this.PollingIntervalUpDown.Minimum = new System.Decimal(new int[] {
                                                                                  1000,
                                                                                  0,
                                                                                  0,
                                                                                  0});
            this.PollingIntervalUpDown.Name = "PollingIntervalUpDown";
            this.PollingIntervalUpDown.Size = new System.Drawing.Size(88, 22);
            this.PollingIntervalUpDown.TabIndex = 3;
            this.PollingIntervalUpDown.Value = new System.Decimal(new int[] {
                                                                                30000,
                                                                                0,
                                                                                0,
                                                                                0});
            this.PollingIntervalUpDown.Enter += new System.EventHandler(this.PollingIntervalUpDown_Enter);
            // 
            // EventLogListenerInputControl
            // 
            this.Name = "EventLogListenerInputControl";
            this.InputGroup.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.PollingIntervalUpDown)).EndInit();

        }
		#endregion

        private void PollingIntervalUpDown_Enter(object sender, System.EventArgs e)
        {
            PollingIntervalUpDown.Select(0, PollingIntervalUpDown.Value.ToString().Length);
        }

        public override string ToString(string innerString)
        {
            const string AssemblyID = "eventlog-listener";
            const string AssemblyType = "Syslog.Listener.SimpleEventLogListener";
            const string AssemblyName = "mlog_listen";
            const string EventLogElement = "eventlog";
            const string EventLogTarget = "target";
            const string EventLogInterval = "interval";

            XmlDocument doc = new XmlDocument();
            XmlElement element = doc.CreateElement(EventLogElement);

            XmlAttribute TargetAttribute = doc.CreateAttribute(EventLogTarget);
            TargetAttribute.Value = EventLogListCombo.SelectedValue.ToString();

            XmlAttribute IntervalAttribute = doc.CreateAttribute(EventLogInterval);
            IntervalAttribute.Value = PollingIntervalUpDown.Value.ToString();

            element.Attributes.Append(TargetAttribute);
            element.Attributes.Append(IntervalAttribute);

            AssemblyElementCreator AssemblyCreator = new AssemblyElementCreator(AssemblyID, AssemblyType, AssemblyName);
            XmlNode AssemblyNode = doc.ImportNode(AssemblyCreator.ToNode(element), true);

            doc.AppendChild(AssemblyNode);

            return doc.OuterXml;
        }
	}
}

