using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Diagnostics;
using System.ServiceProcess;
using System.Windows.Forms;

namespace Syslog.Console.Controls
{
	/// <summary>
	/// ServiceConsoleControl ̊Tv̐łB
	/// </summary>
	public class ServiceConsoleControl : System.Windows.Forms.UserControl
	{
        private System.ComponentModel.IContainer components;
        private System.Windows.Forms.GroupBox ServiceGroup;
        private System.Windows.Forms.Label CurrentStatusLabel;
        private System.Windows.Forms.Label CurrentStatus;
        private System.Windows.Forms.Label StartupModeLabel;
        private System.Windows.Forms.Label StartArgumentLabel;
        private System.Windows.Forms.TextBox StartArgument;
        private System.Windows.Forms.ComboBox StartupMode;
        private System.Windows.Forms.Button StartButton;
        private System.Windows.Forms.Button StopButton;
        private System.Windows.Forms.Button PauseButton;
        private System.Windows.Forms.Button RestartButton;
        private System.Windows.Forms.Button ApplyButton;
        private System.Windows.Forms.Timer StatusPollingTimer;
        private System.Windows.Forms.ToolTip StatusControllerTip;

        private SyslogServiceProcess SyslogService = null;

		public ServiceConsoleControl()
		{
			// ̌ĂяóAWindows.Forms tH[ fUCiŕKvłB
			InitializeComponent();
            
            ServiceStartupModeType[] StartupModeList =
                new ServiceStartupModeType[] {
                                                 new ServiceStartupModeType(ServiceStartupMode.Automatic),
                                                 new ServiceStartupModeType(ServiceStartupMode.Manual),
                                                 new ServiceStartupModeType(ServiceStartupMode.Disabled)
                                             };

            StartupMode.DataSource = StartupModeList;
            StartupMode.DisplayMember = "DisplayName";
            StartupMode.ValueMember = "Mode";
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}

			base.Dispose( disposing );
		}

		#region R|[lg fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            this.ServiceGroup = new System.Windows.Forms.GroupBox();
            this.StartButton = new System.Windows.Forms.Button();
            this.StartupMode = new System.Windows.Forms.ComboBox();
            this.StartArgument = new System.Windows.Forms.TextBox();
            this.CurrentStatus = new System.Windows.Forms.Label();
            this.CurrentStatusLabel = new System.Windows.Forms.Label();
            this.StartupModeLabel = new System.Windows.Forms.Label();
            this.StartArgumentLabel = new System.Windows.Forms.Label();
            this.StopButton = new System.Windows.Forms.Button();
            this.PauseButton = new System.Windows.Forms.Button();
            this.RestartButton = new System.Windows.Forms.Button();
            this.ApplyButton = new System.Windows.Forms.Button();
            this.StatusPollingTimer = new System.Windows.Forms.Timer(this.components);
            this.StatusControllerTip = new System.Windows.Forms.ToolTip(this.components);
            this.ServiceGroup.SuspendLayout();
            this.SuspendLayout();
            // 
            // ServiceGroup
            // 
            this.ServiceGroup.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
                | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.ServiceGroup.Controls.Add(this.StartButton);
            this.ServiceGroup.Controls.Add(this.StartupMode);
            this.ServiceGroup.Controls.Add(this.StartArgument);
            this.ServiceGroup.Controls.Add(this.CurrentStatus);
            this.ServiceGroup.Controls.Add(this.CurrentStatusLabel);
            this.ServiceGroup.Controls.Add(this.StartupModeLabel);
            this.ServiceGroup.Controls.Add(this.StartArgumentLabel);
            this.ServiceGroup.Controls.Add(this.StopButton);
            this.ServiceGroup.Controls.Add(this.PauseButton);
            this.ServiceGroup.Controls.Add(this.RestartButton);
            this.ServiceGroup.Controls.Add(this.ApplyButton);
            this.ServiceGroup.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.ServiceGroup.Location = new System.Drawing.Point(8, 8);
            this.ServiceGroup.Name = "ServiceGroup";
            this.ServiceGroup.Size = new System.Drawing.Size(584, 336);
            this.ServiceGroup.TabIndex = 0;
            this.ServiceGroup.TabStop = false;
            this.ServiceGroup.Text = "Managed Syslog Server";
            // 
            // StartButton
            // 
            this.StartButton.Enabled = false;
            this.StartButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.StartButton.Location = new System.Drawing.Point(56, 256);
            this.StartButton.Name = "StartButton";
            this.StartButton.Size = new System.Drawing.Size(104, 32);
            this.StartButton.TabIndex = 7;
            this.StartButton.Text = "Jn(&S)";
            this.StatusControllerTip.SetToolTip(this.StartButton, "~ Managed Syslog Server T[rXJn܂");
            this.StartButton.Click += new System.EventHandler(this.StartButton_Click);
            // 
            // StartupMode
            // 
            this.StartupMode.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.StartupMode.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
            this.StartupMode.Location = new System.Drawing.Point(200, 94);
            this.StartupMode.Name = "StartupMode";
            this.StartupMode.Size = new System.Drawing.Size(320, 22);
            this.StartupMode.TabIndex = 3;
            this.StatusControllerTip.SetToolTip(this.StartupMode, "Managed Syslog Server T[rX̊Jn̎ނI܂");
            this.StartupMode.SelectionChangeCommitted += new System.EventHandler(this.StartupMode_SelectionChangeCommitted);
            // 
            // StartArgument
            // 
            this.StartArgument.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
                | System.Windows.Forms.AnchorStyles.Right)));
            this.StartArgument.Enabled = false;
            this.StartArgument.Location = new System.Drawing.Point(200, 200);
            this.StartArgument.Name = "StartArgument";
            this.StartArgument.Size = new System.Drawing.Size(320, 22);
            this.StartArgument.TabIndex = 5;
            this.StartArgument.Text = "";
            this.StatusControllerTip.SetToolTip(this.StartArgument, "Managed Syslog Server T[rX̊JnɊJnp[^n܂");
            this.StartArgument.EnabledChanged += new System.EventHandler(this.StartArgument_EnabledChanged);
            this.StartArgument.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.StartArgument_KeyPress);
            // 
            // CurrentStatus
            // 
            this.CurrentStatus.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.CurrentStatus.Location = new System.Drawing.Point(200, 48);
            this.CurrentStatus.Name = "CurrentStatus";
            this.CurrentStatus.Size = new System.Drawing.Size(216, 23);
            this.CurrentStatus.TabIndex = 1;
            this.CurrentStatus.Text = "T[rXCXg[Ă܂B";
            this.StatusControllerTip.SetToolTip(this.CurrentStatus, "Managed Syslog Server T[rX̏Ԃ\܂");
            // 
            // CurrentStatusLabel
            // 
            this.CurrentStatusLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.CurrentStatusLabel.Location = new System.Drawing.Point(56, 48);
            this.CurrentStatusLabel.Name = "CurrentStatusLabel";
            this.CurrentStatusLabel.Size = new System.Drawing.Size(136, 23);
            this.CurrentStatusLabel.TabIndex = 0;
            this.CurrentStatusLabel.Text = "T[rX̏:";
            this.StatusControllerTip.SetToolTip(this.CurrentStatusLabel, "Managed Syslog Server T[rX̏Ԃ\܂");
            // 
            // StartupModeLabel
            // 
            this.StartupModeLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.StartupModeLabel.Location = new System.Drawing.Point(56, 88);
            this.StartupModeLabel.Name = "StartupModeLabel";
            this.StartupModeLabel.Size = new System.Drawing.Size(136, 23);
            this.StartupModeLabel.TabIndex = 2;
            this.StartupModeLabel.Text = "X^[gAbv̎(&E):";
            this.StatusControllerTip.SetToolTip(this.StartupModeLabel, "Managed Syslog Server T[rX̊Jn̎ނI܂");
            // 
            // StartArgumentLabel
            // 
            this.StartArgumentLabel.Enabled = false;
            this.StartArgumentLabel.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.StartArgumentLabel.Location = new System.Drawing.Point(56, 200);
            this.StartArgumentLabel.Name = "StartArgumentLabel";
            this.StartArgumentLabel.Size = new System.Drawing.Size(136, 23);
            this.StartArgumentLabel.TabIndex = 4;
            this.StartArgumentLabel.Text = "Jnp[^(&M):";
            this.StatusControllerTip.SetToolTip(this.StartArgumentLabel, "Managed Syslog Server T[rX̊JnɊJnp[^n܂");
            // 
            // StopButton
            // 
            this.StopButton.Enabled = false;
            this.StopButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.StopButton.Location = new System.Drawing.Point(176, 256);
            this.StopButton.Name = "StopButton";
            this.StopButton.Size = new System.Drawing.Size(104, 32);
            this.StopButton.TabIndex = 8;
            this.StopButton.Text = "~(&T)";
            this.StatusControllerTip.SetToolTip(this.StopButton, "s Managed Syslog Server T[rX~܂");
            this.StopButton.Click += new System.EventHandler(this.StopButton_Click);
            // 
            // PauseButton
            // 
            this.PauseButton.Enabled = false;
            this.PauseButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.PauseButton.Location = new System.Drawing.Point(296, 256);
            this.PauseButton.Name = "PauseButton";
            this.PauseButton.Size = new System.Drawing.Size(104, 32);
            this.PauseButton.TabIndex = 9;
            this.PauseButton.Text = "ꎞ~(&P)";
            this.StatusControllerTip.SetToolTip(this.PauseButton, "s Managed Syslog Server T[rXꎞ~܂");
            this.PauseButton.Click += new System.EventHandler(this.PauseButton_Click);
            // 
            // RestartButton
            // 
            this.RestartButton.Enabled = false;
            this.RestartButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.RestartButton.Location = new System.Drawing.Point(416, 256);
            this.RestartButton.Name = "RestartButton";
            this.RestartButton.Size = new System.Drawing.Size(104, 32);
            this.RestartButton.TabIndex = 10;
            this.RestartButton.Text = "ĊJ(&R)";
            this.StatusControllerTip.SetToolTip(this.RestartButton, "ꎞ~ Managed Syslog Server T[rXĊJ܂");
            this.RestartButton.Click += new System.EventHandler(this.RestartButton_Click);
            // 
            // ApplyButton
            // 
            this.ApplyButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.ApplyButton.Enabled = false;
            this.ApplyButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.ApplyButton.Location = new System.Drawing.Point(416, 134);
            this.ApplyButton.Name = "ApplyButton";
            this.ApplyButton.Size = new System.Drawing.Size(104, 32);
            this.ApplyButton.TabIndex = 6;
            this.ApplyButton.Text = "Kp(&A)";
            this.StatusControllerTip.SetToolTip(this.ApplyButton, "X^[gAbv̎ނo^܂");
            this.ApplyButton.Click += new System.EventHandler(this.ApplyButton_Click);
            // 
            // StatusPollingTimer
            // 
            this.StatusPollingTimer.Enabled = true;
            this.StatusPollingTimer.Interval = 3000;
            this.StatusPollingTimer.Tick += new System.EventHandler(this.StatusPollingTimer_Tick);
            // 
            // ServiceConsoleControl
            // 
            this.Controls.Add(this.ServiceGroup);
            this.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
            this.Name = "ServiceConsoleControl";
            this.Size = new System.Drawing.Size(600, 350);
            this.Load += new System.EventHandler(this.ServiceConsoleControl_Load);
            this.ServiceGroup.ResumeLayout(false);
            this.ResumeLayout(false);

        }
		#endregion

        private void ServiceConsoleControl_Load(object sender, System.EventArgs e)
        {
            try
            {
                SyslogService = new SyslogServiceProcess();

                // T[rX̏Ԃɍ킹ăRg[XV
                this.UpdateServiceStatus();
            }
            catch (InvalidOperationException)
            {
                this.Enabled = false;
            }
        }

        private void StartupMode_SelectionChangeCommitted(object sender, System.EventArgs e)
        {
            // T[rX̃X^[gAbv̎ނύXKp{^Lɂ
            ApplyButton.Enabled = true;
        }

        private void StartArgument_EnabledChanged(object sender, System.EventArgs e)
        {
            // xeLXg{bNXƓԂɕύX
            StartArgumentLabel.Enabled = StartArgument.Enabled;
        }

        private void StartArgument_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
        {
            if (e.KeyChar == (char) Keys.Enter)
            {
                if (StartButton.Enabled)
                {
                    StartButton.Select();
                    StartButton.PerformClick();

                    e.Handled = true;
                }
            }
        }

        private void ApplyButton_Click(object sender, System.EventArgs e)
        {
            const string RegstryAccessError = "T[rX̐ݒύX邽߂̌Ă܂B\r\nǗҌAJEgŎsĂB";

            try
            {
                // T[rX̊Jn[hWXgɏ
                SyslogService.StartupMode = (ServiceStartupMode) StartupMode.SelectedValue;

                // Kp{^𖳌ɂ
                ApplyButton.Enabled = false;
                // Jn[hꗗhbv_ER{ɃtH[JXZbg
                StartupMode.Focus();
            }
            catch (System.Security.SecurityException ex)
            {
                MessageBox.Show(RegstryAccessError, ex.Message);
            }
        }

        private void StartButton_Click(object sender, System.EventArgs e)
        {
            SyslogService.Start(new string[] {StartArgument.Text});

            this.UpdateServiceStatus();
        }

        private void StopButton_Click(object sender, System.EventArgs e)
        {
            SyslogService.Stop();

            this.UpdateServiceStatus();
        }

        private void PauseButton_Click(object sender, System.EventArgs e)
        {
            SyslogService.Pause();
            
            this.UpdateServiceStatus();
        }

        private void RestartButton_Click(object sender, System.EventArgs e)
        {
            SyslogService.Continue();
            
            this.UpdateServiceStatus();
        }

        private void StatusPollingTimer_Tick(object sender, System.EventArgs e)
        {
            System.Windows.Forms.Control Focused = this.ActiveControl;

            try
            {
                this.UpdateServiceStatus();

                this.Enabled = true;
                this.ActiveControl = Focused;
            }
            catch
            {
                this.Enabled = false;
            }
        }

        private void UpdateServiceStatus()
        {
            SyslogService.Refresh();

            // T[rX̃X^[gAbv̎
            StartupMode.SelectedIndex = StartupMode.FindString(ServiceStartupModeType.ToString(SyslogService.StartupMode));

            // Rg[̏ԂXV
            this.UpdateServiceControlStatus(SyslogService.Status);
        }

        private void UpdateServiceControlStatus(ServiceControllerStatus status)
        {
            StartArgument.Enabled = false;

            switch (status)
            {
                // T[rX͎sĂ܂
                case ServiceControllerStatus.Stopped:
                {
                    CurrentStatus.Text = "~";
                    StartArgument.Enabled = true;

                    StartButton.Enabled = true;
                    StopButton.Enabled = false;
                    PauseButton.Enabled = false;
                    RestartButton.Enabled = false;

                    break;
                }
                // T[rX͎sł
                case ServiceControllerStatus.Running:
                {
                    CurrentStatus.Text = "Jn";

                    StartButton.Enabled = false;
                    StopButton.Enabled = true;
                    PauseButton.Enabled = true;
                    RestartButton.Enabled = false;

                    break;
                }
                // T[rX͈ꎞ~Ă܂
                case ServiceControllerStatus.Paused:
                {
                    CurrentStatus.Text = "ꎞ~";

                    StartButton.Enabled = false;
                    StopButton.Enabled = true;
                    PauseButton.Enabled = false;
                    RestartButton.Enabled = true;

                    break;
                }
                // T[rX͊Jnł
                case ServiceControllerStatus.StartPending:
                {
                    CurrentStatus.Text = "JnĂ܂...";

                    StartButton.Enabled = false;
                    StopButton.Enabled = false;
                    PauseButton.Enabled = false;
                    RestartButton.Enabled = false;

                    break;
                }
                // T[rX͒~ł
                case ServiceControllerStatus.StopPending:
                {
                    CurrentStatus.Text = "~Ă܂...";

                    StartButton.Enabled = false;
                    StopButton.Enabled = false;
                    PauseButton.Enabled = false;
                    RestartButton.Enabled = false;

                    break;
                }
                // T[rX̌p͗ےł
                case ServiceControllerStatus.ContinuePending:
                {
                    CurrentStatus.Text = "ĊJĂ܂...";

                    StartButton.Enabled = false;
                    StopButton.Enabled = false;
                    PauseButton.Enabled = false;
                    RestartButton.Enabled = false;

                    break;
                }
                // T[rẌꎞf͗ےł
                case ServiceControllerStatus.PausePending:
                {
                    CurrentStatus.Text = "ꎞ~Ă܂...";

                    StartButton.Enabled = false;
                    StopButton.Enabled = false;
                    PauseButton.Enabled = false;
                    RestartButton.Enabled = false;

                    break;
                }
            }

            // T[rẌꎞ~ƍĊJT|[gĂȂꍇ
            if (!SyslogService.CanPauseAndContinue)
            {
                PauseButton.Enabled = false;
                RestartButton.Enabled = false;
            }
        }
	}
}
