using System;
using System.Collections;
using System.ComponentModel;
using System.Diagnostics;
using System.Reflection;
using System.ServiceProcess;

namespace Syslog.Service
{
    /// <summary>
    /// Windows Service Controll Manager (SCM)ƑΘbsGg|CgB
    /// </summary>
	public class ServiceController : System.ServiceProcess.ServiceBase
	{
        private const string ConsoleHelpSwitch1 = "/?";
        private const string ConsoleHelpSwitch2 = "-?";
        private const string ConsoleHelpSwitch3 = "--?";
        private const string ConsoleModeSwitch = "--console";
        private const string ConsoleTraceModeSwitch = "--trace";
        private const string ConsoleExitKey = "q";

        internal static readonly string SyslogServiceName = "mLogServer";

		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		private System.ComponentModel.Container components = null;

        private ServiceComponent service = null;
        private TextWriterTraceListener ConsoleListener = null;

        /// <summary>
        /// RXgN^B
        /// </summary>
		public ServiceController()
		{
			// ̌ĂяóAWindows.Forms R|[lg fUCiŕKvłB
			InitializeComponent();
		}

		// ̃C Gg |CgłB
		static void Main(string[] args)
        {
            const string Product = "Managed Syslog Server, {0}";
            const string Copyright = "Copyright (C) 2004 `I. All rights reserved.";
            const string CreativeCommons = "̍íANGCeBuERY̋A - cCZX̉ŃCZXĂ܂B̎gpɂ́Ahttp://creativecommons.org/licenses/by-nc/1.0/ `FbN邩ANGCeBuRYɗXւɂĂ₢킹BŹF559 Nathan Abbott Way, Stanford, California 94305, USA łB";

            string ProductInfo = String.Format(Product, Assembly.GetExecutingAssembly().GetName().Version.ToString());

            Console.WriteLine();
            Console.WriteLine(ProductInfo);
            Console.WriteLine();
            Console.WriteLine(Copyright);
            Console.WriteLine(CreativeCommons);
            Console.WriteLine();

            bool ConsoleMode = false;

            // ׂă`FbN
            foreach (string arg in args)
            {
                // ׂďŔr
                switch (arg.ToLower())
                {
                    // R\[샂[hw肳Ăꍇ
                    case ConsoleModeSwitch:
                    {
                        ConsoleMode = true;

                        break;
                    }
                    // wvXCb`w肳Ăꍇ
                    case ConsoleHelpSwitch1:
                    case ConsoleHelpSwitch2:
                    case ConsoleHelpSwitch3:
                    {
                        Console.WriteLine();
                        Console.WriteLine("mlog_ctl.exe --console --trace -?");
                        Console.WriteLine();
                        Console.WriteLine("\t--console:\tT[rXR\[N܂");
                        Console.WriteLine("\t--trace:\tR\[Ƀg[XbZ[W\܂");
                        Console.WriteLine("\t-?\tR}hC wv\܂");

                        return;
                    }
                }
            }

            // R\[샂[hw肳Ăꍇ
            if (ConsoleMode)
            {
                try
                {
                    // T[rXJn
                    ServiceController service = new ServiceController();
                    service.OnStart(args);

                    Console.WriteLine();
                    Console.WriteLine("Managed Syslog Server Started.");
                    Console.WriteLine(String.Format("Press the \"{0}\" + ENTER key for stopping this service.", ConsoleExitKey));

                    // IR}h͂܂ŃR\[͂`FbN
                    while (Console.ReadLine().ToLower() != ConsoleExitKey)
                    {
                    }

                    Console.WriteLine();

                    // T[rX~
                    service.OnStop();

                    Console.WriteLine();
                    Console.WriteLine("Managed Syslog Server Stopped.");
                }
                catch (Exception e)
                {
                    // G[\
                    Console.WriteLine(e.ToString());
                }

                // AvP[ṼC Gg |Cg𔲂
                return;
            }

            // T[rXAvP[ṼfobÔ8bԃX[v܂
            //System.Threading.Thread.Sleep(8000);

			System.ServiceProcess.ServiceBase[] ServicesToRun;
	
			// 2 ȏ NT T[rX𓯂Ŏsł܂Bʂ̃T[rX
			// ̏ɒǉɂ́Aȉ̍sύX
			// 2 Ԗڂ̃T[rX IuWFNg쐬ĂB :
			//
			//   ServicesToRun = New System.ServiceProcess.ServiceBase[] {new Service1(), new MySecondUserService()};
			//
			ServicesToRun = new System.ServiceProcess.ServiceBase[] { new ServiceController() };

            // T[rX{̂̃bZ[W[vXbhJn܂
            System.ServiceProcess.ServiceBase.Run(ServicesToRun);
		}

		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
            // 
            // ServiceController
            // 
            this.CanShutdown = true;

        }

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}

                if (service != null)
                {
                    service.Dispose();
                }
			}

			base.Dispose( disposing );
		}

		/// <summary>
		/// 삪؂ȂsAT[rX̎sWȂ悤ɐݒ肵܂B
		/// </summary>
		protected override void OnStart(string[] args)
        {
            // Jnp[^ǂݍ
            this.ParseArgument(args);

            // R\[ g[X [hw肳Ăꍇ
            if (ConsoleListener != null)
            {
                // eLXgg[XXȉo͂R\[ɕ\
                Trace.Listeners.Add(ConsoleListener);
            }

            Trace.WriteLine(String.Format("Trace started in {0}.", DateTime.Now.ToString()));
            Trace.WriteLine("Managed Syslog Server Begin OnStart()", "Syslog.Service.ServiceController");

            service = new ServiceComponent();
            service.Start();
            
            Trace.WriteLine("Managed Syslog Server End OnStart()", "Syslog.Service.ServiceController");
		}
 
		/// <summary>
		/// ̃T[rX~܂B
		/// </summary>
		protected override void OnStop()
		{
            Trace.WriteLine("Managed Syslog Server Begin OnStop()", "Syslog.Service.ServiceController");

            service.Stop();

            Trace.WriteLine("Managed Syslog Server End OnStop()", "Syslog.Service.ServiceController");
            Trace.WriteLine(String.Format("Trace stopped in {0}.", DateTime.Now.ToString()));

            // R\[ g[X [hw肳Ăꍇ
            if (ConsoleListener != null)
            {
                // eLXgg[XXȉo͂R\[ɕ\
                Trace.Listeners.Remove(ConsoleListener);
            }
		}

        /// <summary>
        /// VXeVbg_EOɂ̃T[rX~܂B
        /// </summary>
        protected override void OnShutdown()
        {
            Trace.WriteLine("Managed Syslog Server Begin OnShutdown()", "Syslog.Service.ServiceController");

            // T[rX~܂
            this.OnStop();

            Trace.WriteLine("Managed Syslog Server End OnShutdown()", "Syslog.Service.ServiceController");
            Trace.WriteLine(String.Format("Trace stopped in {0}.", DateTime.Now.ToString()));
        }

        /// <summary>
        /// ꎞ~̃T[rXĊJ܂B
        /// </summary>
        protected override void OnContinue()
        {
            // TODO: ĊJ/ꎞ~̃oO
            Trace.WriteLine("Managed Syslog Server Begin OnContinue()", "Syslog.Service.ServiceController");

            service.Continue();
            
            Trace.WriteLine("Managed Syslog Server End OnContinue()", "Syslog.Service.ServiceController");
        }

        /// <summary>
        /// ̃T[rXꎞ~܂B
        /// </summary>
        protected override void OnPause()
        {
            Trace.WriteLine("Managed Syslog Server Begin OnPause()", "Syslog.Service.ServiceController");

            service.Pause();
            
            Trace.WriteLine("Managed Syslog Server End OnPause()", "Syslog.Service.ServiceController");
        }

        /// <summary>
        /// dǗCxgMď܂B
        /// </summary>
        /// <param name="powerStatus">VXe̓dX^[^XʒmB</param>
        /// <returns>dǗCxg̃NG։܂B</returns>
        protected override bool OnPowerEvent(PowerBroadcastStatus powerStatus)
        {
            Trace.WriteLine("Managed Syslog Server OnPowerEvent()", "Syslog.Service.ServiceController");
            Trace.Indent();
            Trace.WriteLine(powerStatus.ToString());

            return base.OnPowerEvent (powerStatus);
        }


        private void ParseArgument(string[] args)
        {
            // ׂă`FbN
            foreach (string arg in args)
            {
                // ׂďŔr
                switch (arg.ToLower())
                {
                    // R\[ g[X [hw肳Ăꍇ
                    case ConsoleTraceModeSwitch:
                    {
                        ConsoleListener = new TextWriterTraceListener(Console.Out);

                        break;
                    }
                }
            }
        }
	}
}
