using System;
using System.Globalization;
using System.Reflection;
using System.Text;
using System.Xml;

namespace Syslog.Config
{
	/// <summary>
	/// \ZNVǂݎAZȕi[܂B
	/// </summary>
	public class AssemblyEntry : ICloneable
	{
        private AssemblyName assemblyInfo = new AssemblyName();
        private string id = String.Empty;
        private string type = String.Empty;
        private string config = String.Empty;

        /// <summary>
        /// ftHgRXgN^B
        /// </summary>
		public AssemblyEntry()
		{
		}

        /// <summary>
        /// ̃CX^XێĂɃAZu[h܂B
        /// </summary>
        /// <returns>̃CX^XێĂɃ[h <see cref="Assembly"/>B</returns>
        public Assembly GetAssembly()
        {
            // AZũpXw肳Ăꍇ
            if (assemblyInfo.CodeBase != null && assemblyInfo.CodeBase != String.Empty)
            {
                // w肵pXAZu[h
                return Assembly.LoadFile(System.IO.Path.GetFullPath(assemblyInfo.CodeBase));
            }
            // AZũpXw肳ĂȂꍇ
            else
            {
                // AssemblyName găAZu[h܂
                return Assembly.Load(this.assemblyInfo);
            }
        }

        /// <summary>
        /// ̃CX^XێĂ񂩂AZu[hCX^X쐬܂B
        /// </summary>
        /// <returns>̃CX^XێĂɃ[h쐬ꂽVCX^XB</returns>
        public object CreateInstance()
        {
            // AZu[hCX^X쐬܂
            return this.CreateInstance(this.GetAssembly());
        }

        /// <summary>
        /// ̃CX^XێĂ񂩂AZu[hnăCX^X쐬܂
        /// </summary>
        /// <param name="arg">CX^X쐬ƂɃRXgN^֓nB</param>
        /// <returns>̃CX^XێĂɃ[h쐬ꂽVCX^XB</returns>
        public object CreateInstance(params object[] arg)
        {
            // AZu[hnăCX^X쐬܂
            return this.CreateInstance(this.GetAssembly(), arg);
        }

        /// <summary>
        /// w肳ꂽ <see cref="Assembly"/>  <see cref="AssemblyEntry.Type"/> TCX^X쐬B
        /// </summary>
        /// <param name="assembly"><see cref="AssemblyEntry.Type"/> T <see cref="Assembly"/>B</param>
        /// <returns>
        /// <para>̃CX^XێĂɃ[h쐬ꂽVCX^XB</para>
        /// <para><see cref="Type"/> Ȃꍇ null QƁB</para></returns>
        public object CreateInstance(Assembly assembly)
        {
            // Assembly w肵 Type ̃CX^X쐬
            return assembly.CreateInstance(this.Type, true);
        }

        /// <summary>
        /// w肳ꂽ <see cref="Assembly"/>  <see cref="AssemblyEntry.Type"/> TnăCX^X쐬B
        /// </summary>
        /// <param name="assembly"><see cref="AssemblyEntry.Type"/> T <see cref="Assembly"/>B</param>
        /// <param name="arg">CX^X쐬ƂɃRXgN^֓nB</param>
        /// <returns>
        /// <para>̃CX^XێĂɃ[h쐬ꂽVCX^XB</para>
        /// <para><see cref="Type"/> Ȃꍇ null QƁB</para></returns>
        public object CreateInstance(Assembly assembly, params object[] arg)
        {
            // Assembly w肵 Type ɈnăCX^X쐬
            return assembly.CreateInstance(this.Type, true, BindingFlags.CreateInstance, null, arg, null, null);
        }

        /// <summary>
        /// AZǔJg[N <see cref="Byte"/> zŎ擾܂B
        /// </summary>
        /// <returns>AZǔJg[N <see cref="Byte"/> zB</returns>
        public byte[] GetPublicKeyToken()
        {
            return this.assemblyInfo.GetPublicKeyToken();
        }

        /// <summary>
        /// AZǔJg[Nݒ肵܂B
        /// </summary>
        /// <returns>AZǔJg[N <see cref="Byte"/> zB</returns>
        public void SetPublicKeyToken(byte[] token)
        {
            this.assemblyInfo.SetPublicKeyToken(token);
        }

        /// <summary>
        /// AZu <see cref="CultureInfo"/> 擾܂B
        /// </summary>
        /// <returns>AZuĂ <see cref="CultureInfo"/>B</returns>
        public CultureInfo GetCultureInfo()
        {
            return this.assemblyInfo.CultureInfo;
        }

        /// <summary>
        /// AZu <see cref="CultureInfo"/> ݒ肵܂B
        /// </summary>
        /// <param name="culture">ݒ肷 <see cref="CultureInfo"/>B</param>
        public void SetCultureInfo(CultureInfo culture)
        {
            this.assemblyInfo.CultureInfo = culture;
        }

        /// <summary>
        /// AZu̍\ZNVłID擾܂͐ݒ肵܂B
        /// </summary>
        public string ID
        {
            get
            {
                return id;
            }
            set
            {
                if (value != null)
                {
                    id = value;
                }
                else
                {
                    throw new ArgumentNullException("ID");
                }
            }
        }

        /// <summary>
        /// AZu̍\ZNVł̃NX擾܂͐ݒ肵܂
        /// </summary>
        public string Type
        {
            get
            {
                return type;
            }
            set
            {
                if (value == null)
                {
                    throw new ArgumentNullException("Type");
                }
                else if (value == String.Empty)
                {
                    throw new ArgumentException("Type ̕ł");
                }
                else
                {
                    type = value;
                }
            }
        }

        /// <summary>
        /// AZu̍\ZNVł̃AZu擾܂͐ݒ肵܂
        /// </summary>
        public string Name
        {
            get
            {
                return assemblyInfo.Name;
            }
            set
            {
                assemblyInfo.Name = value;
            }
        }

        /// <summary>
        /// AZu̍\ZNVł̌Jg[N擾܂͐ݒ肵܂B
        /// </summary>
        public string PublicKeyToken
        {
            get
            {
                // Jg[NoCgz񂩂當ɕϊĕԂ܂
                return this.ByteToHex(this.GetPublicKeyToken());
            }
            set
            {
                // Jg[Nw肳ꂽꍇ
                if (value != null && value != String.Empty)
                {
                    // Jg[N𕶎񂩂oCgzɕϊĊi[܂
                    this.SetPublicKeyToken(this.HexToByte(value));
                }
                // Jg[Nw肳Ȃꍇ
                else
                {
                    // Jg[N null QƂɂ
                    this.SetPublicKeyToken(null);
                }
            }
        }

        /// <summary>
        /// AZu̍\ZNVł̃J`擾܂͐ݒ肵܂B
        /// </summary>
        public string Culture
        {
            get
            {
                // J`̕\L擾
                string CultureName = this.GetCultureInfo().Name;

                // J`󕶎̏ꍇ
                if (CultureName == String.Empty)
                {
                    // j[gԂ
                    return "Neutral";
                }
                // J`ꍇ
                else
                {
                    // J`Ԃ
                    return CultureName;
                }
            }
            set
            {
                // J` null QƂ̏ꍇ
                if (value == null)
                {
                    // J` null QƂɐݒ肷
                    this.SetCultureInfo(null);
                }
                // J`j[g̏ꍇ
                else if (value.ToLower() == "neutral")
                {
                    // J`ɈˑȂJ`ݒ肷
                    this.SetCultureInfo(CultureInfo.InvariantCulture);
                }
                // J`w肳Ăꍇ
                else
                {
                    // J`Ƀ}b` CultureInfo ݒ肷
                    this.SetCultureInfo(new CultureInfo(value, true));
                }
            }
        }

        /// <summary>
        /// AZu̍\ZNVł̃AZut@CpX擾܂͐ݒ肵܂B
        /// </summary>
        public string Path
        {
            get
            {
                return assemblyInfo.CodeBase;
            }
            set
            {
                assemblyInfo.CodeBase = value;
            }
        }

        /// <summary>
        /// AZu̍\ZNVł̃AZuo[W擾܂͐ݒ肵܂B
        /// </summary>
        public string Version
        {
            get
            {
                return assemblyInfo.Version.ToString();
            }
            set
            {
                assemblyInfo.Version = new Version(value);
            }
        }

        /// <summary>
        /// AZu̍\ZNVł̒ǉIȎqm[h擾܂͐ݒ肵܂B
        /// </summary>
        public string Config
        {
            get
            {
                return config;
            }
            set
            {
                if (value != null)
                {
                    config = value;
                }
                else
                {
                    config = String.Empty;
                }
            }
        }

        #region ICloneable o
        /// <summary>
        /// <see cref="AssemblyEntry"/> ̊SȃRs[쐬܂B
        /// </summary>
        /// <returns><see cref="AssemblyEntry"/> ̊SȃRs[B</returns>
        public object Clone()
        {
            // AssemblyEntry ̊ȈՃRs[擾
            AssemblyEntry entry = (AssemblyEntry) this.MemberwiseClone();
            // AssemblyInfo ̊SȃRs[擾Đݒ肷
            entry.assemblyInfo = (AssemblyName) this.assemblyInfo.Clone();

            // AssemblyEntry ̊SȃRs[Ԃ
            return entry;
        }
        #endregion
        
        /// <summary>
        /// \L̃oCg <see cref="Byte"/> zɕϊ܂B
        /// </summary>
        /// <param name="Token"><see cref="Byte"/> zɕϊ镶B</param>
        /// <returns>񂩂ϊ <see cref="Byte"/> zB</returns>
        private byte[] HexToByte(string Token)
        {
            int j = 0;
            string TokenString = Token;

            // 2oCgzɊi[
            Byte[] ByteToken = new Byte[TokenString.Length / 2];

            try
            {
                // 2oCg[v
                for (int i = 0; i < TokenString.Length - 1; i += 2)
                {
                    // 16i\L̕oCgɕϊ
                    ByteToken[j] = Byte.Parse(String.Concat(TokenString[i], TokenString[i + 1]), NumberStyles.HexNumber);

                    j++;
                }
            }
            catch {}

            // oCgzԂ
            return ByteToken;
        }

        /// <summary>
        /// <see cref="Byte"/> zϊĕŕ\ <see cref="String"/> ɕϊ܂B
        /// </summary>
        /// <param name="token">ɕϊ <see cref="Byte"/> zB</param>
        /// <returns><see cref="Byte"/> z񂩂當\Lɕϊꂽ <see cref="String"/>B</returns>
        public string ByteToHex(byte[] token)
        {
            StringBuilder TokenBuilder = new StringBuilder(token.Length * 2);

            foreach (byte bit in token)
            {
                // \L16iɃoCgϊ
                TokenBuilder.Append(bit.ToString("x"));
            }

            // oCgz̕\LԂ܂
            return TokenBuilder.ToString();
        }
    }
}
