using System;
using System.Collections;
using System.Configuration;
using System.Diagnostics;
using System.Text;

namespace Syslog.Config
{
    /// <summary>
    /// sȃtH[}bg̃pPbg̏@킷l
    /// </summary>
    public enum ErrorPacketRuleType
    {
        /// <summary>pPbg̏𑱂</summary>
        Ignore  = 0,
        /// <summary>pPbgj</summary>
        Drop    = 1,
        /// <summary>pPbgjăOL^</summary>
        Reject  = 2
    }

    /// <summary>
    /// app.config ݒt@CsȃpPbg̏@擾܂
    /// </summary>
    /// <example>
    /// <para>\t@CݒB</para>
    /// <code>&lt;errorPacket rule="ignore|drop|reject" /&gt;</code>
    /// <list type="table">
    ///     <listheader>
    ///         <term></term>
    ///         <description>ݒl</description>
    ///     </listheader>
    ///     <item>
    ///         <term>ingore</term>
    ///         <description>sȃpPbg̏̂܂ܑ܂B</description>
    ///     </item>
    ///     <item>
    ///         <term>drop</term>
    ///         <description>sȃpPbgj܂B</description>
    ///     </item>
    ///     <item>
    ///         <term>reject</term>
    ///         <description>sȃpPbg͔j̃O𑗐M܂B</description>
    ///     </item>
    /// </list>
    /// </example>
    public class ErrorPacketRule
    {
        /// <summary>syslogConfig/settings/errorPacket</summary>
        private const string ConfigErrorPacketSection = "syslogConfig/settings/errorPacket";
        private const string ConfigErrorPacketKey = "rule";
        /// <summary>ftHg̏@B <see cref="ErrorPacketRuleType"/>.DropB</summary>
        private const ErrorPacketRuleType DefaultErrorPacketRule = ErrorPacketRuleType.Drop;

        /// <summary>
        /// sȃpPbgftHg̏@擾܂B
        /// </summary>
        /// <returns>app.config ̒lɐݒ肳ꂽ <see cref="ErrorPacketRuleType"/>B</returns>
        public static ErrorPacketRuleType GetErrorPacketRule()
        {
            try
            {
                // ݒt@CsȃpPbg̏@ǂݍ
                IDictionary ErrorRule = (IDictionary) ConfigurationSettings.GetConfig(ConfigErrorPacketSection);

                // @ݒ肳Ăꍇ
                if (ErrorRule.Contains(ConfigErrorPacketKey))
                {
                    // ݒ@񋓒lTĕԂ
                    return (ErrorPacketRuleType) Enum.Parse(typeof(ErrorPacketRuleType), ErrorRule[ConfigErrorPacketKey].ToString(), true);
                }
            }
            // ݒt@C琳ݒ肪ǂݍ߂Ȃꍇ
            catch (ArgumentException e)
            {
                Debug.Assert(false, "sȃpPbg̏@ݒt@Cǂݍ߂܂ł!", e.ToString());
                Trace.WriteLine("sȃpPbg̏@ݒt@Cǂݍ߂܂ł!", "Syslog.Listener.ListenerController");
            }

            // ftHg̏@Ԃ
            return DefaultErrorPacketRule;
        }
    }
}
