/*using System;
using System.Collections;
using System.IO;
using System.Reflection;
using System.Text;
using System.Xml;
using System.Xml.XPath;

namespace Syslog.Config
{
    /// <summary>
    /// 
    /// </summary>
    public delegate void ConfigurationChangedEventHandler(object sender, EventArgs e);

	/// <summary>
	/// SyslogConfig ̊Tv̐łB
	/// </summary>
	public class SyslogConfig : AnyContent, ICloneable, IDisposable
	{
        /// <summary>
        /// 
        /// </summary>
        public event ConfigurationChangedEventHandler ConfigurationChanged;

        private FileSystemWatcher watcher = null;
        private AppSettings appSetting = new AppSettings();
        private AppSettings appSettingCache = new AppSettings();
        private AssemblyEntryCollection filterModules = new AssemblyEntryCollection();
        private AssemblyEntryCollection filterModulesCache = new AssemblyEntryCollection();
        private string version = DefaultSetting.Version;

        /// <summary>
        /// 
        /// </summary>
		public SyslogConfig()
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
		}

        /// <summary>
        /// 
        /// </summary>
        /// <param name="setting"></param>
        /// <param name="modules"></param>
        internal SyslogConfig(AppSettings setting, AssemblyEntryCollection modules)
        {
            this.appSetting = setting;
            this.appSettingCache = (AppSettings) setting.Clone();
            this.filterModules = modules;
            this.filterModulesCache = (AssemblyEntryCollection) modules.Clone();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="path"></param>
        public void Load(string path)
        {
            lock (this)
            {
                XmlUrlResolver Resolver = new XmlUrlResolver();
                // ݂̃AZu Evidence 𗘗pURIQƂ
                XmlSecureResolver sResolver = new XmlSecureResolver(Resolver, Assembly.GetExecutingAssembly().Evidence);

                XmlTextReader xr = new XmlTextReader(path);
                xr.Normalization = true;

                XmlValidatingReader Validation = new XmlValidatingReader(xr);
                Validation.ValidationType = ValidationType.Schema;
                // URI
                Validation.XmlResolver = sResolver;
                // ftHg̃XL[}P[VXL[}擾
                Validation.Schemas.Add(DefaultSetting.SchemaNamespace, DefaultSetting.SchemaLocation);

                XmlDocument doc = new XmlDocument();
                // \t@C[h
                doc.Load(Validation);

                // [_N[Y
                Validation.Close();
                
                // XPath Ƀl[Xy[X֘At
                XmlNamespaceManager nsManager = new XmlNamespaceManager(doc.NameTable);
                // ftHgOԂݒ
                nsManager.AddNamespace(String.Empty, DefaultSetting.SchemaNamespace);
                // XPath pɃvtBbNXtOԂݒ
                nsManager.AddNamespace("cf", nsManager.DefaultNamespace);

                // hLg[g̃fB[vRs[ݒ
                this.ConfigNode = (XmlElement) doc.DocumentElement.Clone();

                // tH[}bg o[W擾
                XmlAttribute ConfigVersion = (XmlAttribute) doc.SelectSingleNode("/cf:syslogConfig/@version", nsManager);
                this.Version = ConfigVersion.Value;

                #region AvP[Vݒ胊Xg
                // AvP[VݒNA
                this.appSetting.Clear();

                // AvP[Vݒ胊Xg擾
                XmlNodeList AppSettingList = doc.SelectNodes("/cf:syslogConfig/cf:appSettings/cf:add", nsManager);

                foreach (XmlNode node in AppSettingList)
                {
                    XmlAttributeCollection Attributes = node.Attributes;

                    // ݒlXgɒǉ
                    this.appSetting.Add(Attributes["key"].Value, Attributes["value"].Value);
                }

                // ftHgR[hݒ
                this.appSetting.DefaultEncoding = doc.SelectSingleNode("/cf:syslogConfig/cf:appSettings/@defaultEncoding", nsManager).Value;

                //zXg擾
                XmlAttribute Hostname = (XmlAttribute) doc.SelectSingleNode("/cf:syslogConfig/cf:appSettings/@hostname", nsManager);

                if (Hostname != null)
                {
                    // zXgݒ
                    this.appSetting.Hostname = Hostname.Value;
                }
                else
                {
                    // zXgftHgɐݒ肷
                    this.appSetting.Hostname = null;
                }

                // JX^ݒ̓ǂݏopNodẽfB[vRs[ݒ
                this.appSetting.ConfigNode = (XmlElement) doc.SelectSingleNode("/cf:syslogConfig/cf:appSettings", nsManager).Clone();
                #endregion

                #region o^tB^W[Xg
                // o^tB^W[XgNA
                this.filterModules.Clear();

                // o^tB^W[̃Xg擾
                XmlNodeList FilterModuleList = doc.SelectNodes("/cf:syslogConfig/cf:filterModules/cf:register", nsManager);

                foreach (XmlNode node in FilterModuleList)
                {
                    AssemblyEntry entry = new AssemblyEntry();
                    XmlAttributeCollection Attributes = node.Attributes;

                    entry.ID = Attributes["id"].Value;
                    entry.Type = Attributes["type"].Value;
                    entry.Name = Attributes["name"].Value;

                    if (Attributes["publicKeyToken"] != null)
                    {
                        entry.PublicKeyToken = Attributes["publicKeyToken"].Value;
                    }

                    if (Attributes["culture"] != null)
                    {
                        entry.Culture = Attributes["culture"].Value;
                    }

                    if (Attributes["version"] != null)
                    {
                        entry.Version = Attributes["version"].Value;
                    }

                    // JX^ݒ̓ǂݏopNodẽfB[vRs[ݒ肷
                    //entry.ConfigNode = (XmlElement) node.Clone();

                    // W[Xgɒǉ
                    this.filterModules.Add(entry);
                }

                // o^tB^W[Xg̃JX^ݒǂݏopNodẽfB[vRs[ݒ肷
                //this.FilterModules.ConfigNode = (XmlElement) doc.SelectSingleNode("/cf:syslogConfig/cf:filterModules", nsManager).Clone();
                #endregion


                // LbV𓯊
                this.Update();
            }

            return;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="path"></param>
        public void Save(string path)
        {
            // Xbh𓯊
            lock (this)
            {
                XmlDocument doc = new XmlDocument();

                try
                {
                    #region hLg[h
                    XmlUrlResolver Resolver = new XmlUrlResolver();
                    // ݂̃AZu Evidence 𗘗pURIQƂ
                    XmlSecureResolver sResolver = new XmlSecureResolver(Resolver, Assembly.GetExecutingAssembly().Evidence);

                    XmlTextReader xr = new XmlTextReader(path);
                    xr.Normalization = true;

                    XmlValidatingReader Validation = new XmlValidatingReader(xr);
                    Validation.ValidationType = ValidationType.Schema;
                    // URI
                    Validation.XmlResolver = sResolver;
                    // ftHg̃XL[}P[VXL[}擾
                    Validation.Schemas.Add(DefaultSetting.SchemaNamespace, DefaultSetting.SchemaLocation);

                    // \t@C[h
                    doc.Load(Validation);

                    // [_N[Y
                    Validation.Close();
                
                    // XPath Ƀl[Xy[X֘At
                    XmlNamespaceManager nsManager = new XmlNamespaceManager(doc.NameTable);
                    // ftHgOԂݒ
                    nsManager.AddNamespace(String.Empty, DefaultSetting.SchemaNamespace);
                    // XPath pɃvtBbNXtOԂݒ
                    nsManager.AddNamespace("cf", nsManager.DefaultNamespace);
                    #endregion
                }
                catch
                {
                    // VKhLg쐬
                    doc.LoadXml("");
                }
            }

            // Cxg𔭐
            this.OnConfigurationChanged(this, EventArgs.Empty);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public XmlDocument Save()
        {
            const string xmlns = DefaultSetting.SchemaNamespace;

            XmlDocument doc = new XmlDocument();
            // 󔒂ۑȂ
            doc.PreserveWhitespace = false;

            doc.AppendChild(doc.CreateXmlDeclaration("1.0", DefaultSetting.ConfigEncoding, null));

            // 
            lock (this)
            {
                #region [gGg : syslogConfig
                XmlElement root = doc.CreateElement(null, "syslogConfig", xmlns);
                XmlAttribute version = doc.CreateAttribute("version");
                XmlAttribute xsi = doc.CreateAttribute("xmlns:xsi");
                XmlAttribute schemaLocation = doc.CreateAttribute("xsi:schemaLocation");

                // o[Wݒ
                version.Value = this.Version;
                xsi.Value = "http://www.w3.org/2001/XMLSchema-instance";
                schemaLocation.Value = "urn:schemas-cham-reo-net:ManagedSyslogServer/1.0/SyslogConfigSchema.xsd SyslogConfigSchema.xsd";

                root.Attributes.Append(version);
                root.Attributes.Append(xsi);
                root.Attributes.Append(schemaLocation);
                #endregion

                #region syslogConfig/appConfig
                XmlElement appConfig = doc.CreateElement("appSettings", xmlns);
                XmlAttribute defaultEncoding = doc.CreateAttribute("defaultEncoding");
                XmlAttribute hostname = doc.CreateAttribute("hostname");

                // ftHgGR[fBOݒ
                defaultEncoding.Value = this.appSetting.DefaultEncoding;
                // zXgݒ
                hostname.Value = this.appSetting.Hostname;
                
                // AvP[Vݒǉ
                foreach (string key in this.appSetting)
                {
                    XmlElement appConfigAdd = doc.CreateElement("add", xmlns);
                    XmlAttribute appConfigKey = doc.CreateAttribute("key");
                    XmlAttribute appConfigValue = doc.CreateAttribute("value");

                    // L[ǉ
                    appConfigKey.Value = key;
                    // ݒlǉ
                    appConfigValue.Value = this.appSetting[key];

                    appConfigAdd.Attributes.Append(appConfigKey);
                    appConfigAdd.Attributes.Append(appConfigValue);
                    appConfig.AppendChild(appConfigAdd);
                }

                appConfig.Attributes.Append(defaultEncoding);
                appConfig.Attributes.Append(hostname);
                root.AppendChild(appConfig);
                #endregion

                doc.AppendChild(root);
            }

            return doc;
        }

        /// <summary>
        /// 
        /// </summary>
        public void Update()
        {
            // Update 𓯎ɎsȂ
            lock (this)
            {
                // LbV̍XV𓯊
                lock (appSetting)
                {
                    this.appSettingCache = this.appSetting;
                }

                // LbV̍XV𓯊
                lock (filterModules)
                {
                    this.filterModulesCache = this.filterModules;
                }
            }
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="file"></param>
        public void StartWatch(FileInfo file)
        {
            if (watcher != null && watcher.EnableRaisingEvents)
            {
                throw new Exception();
            }

            watcher = new FileSystemWatcher(file.DirectoryName, file.Name);
            watcher.NotifyFilter = NotifyFilters.LastWrite | NotifyFilters.Size;
            watcher.Changed += new FileSystemEventHandler(watcher_Changed);
            // j^Jn
            watcher.EnableRaisingEvents = true;
        }

        /// <summary>
        /// 
        /// </summary>
        public void EndWatch()
        {
            if (watcher != null)
            {
                watcher.EnableRaisingEvents = false;
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public AppSettings AppSettings
        {
            get
            {
                return (AppSettings) appSettingCache.Clone();
            }
            set
            {
                if (value != null)
                {
                    lock (appSetting)
                    {
                        appSetting = value;
                    }
                }
                else
                {
                    throw new ArgumentNullException("AppSettings");
                }
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public AssemblyEntryCollection FilterModules
        {
            get
            {
                return (AssemblyEntryCollection) filterModulesCache.Clone();
            }
            set
            {
                if (value != null)
                {
                    lock (filterModules)
                    {
                        filterModules = value;
                    }
                }
                else
                {
                    throw new ArgumentNullException("FilterModules");
                }
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public string Version
        {
            get
            {
                return version;
            }
            set
            {
                if (value != null)
                {
                    if (value != DefaultSetting.Version)
                    {
                        throw new ArgumentException("w肳ꂽo[W 1.0 ł͂܂");
                    }
                }
                else
                {
                    throw new ArgumentNullException("Version");
                }
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public bool IsWatched
        {
            get
            {
                if (watcher != null)
                {
                    return watcher.EnableRaisingEvents;
                }
                else
                {
                    return false;
                }
            }
        }

        /// <summary>
        /// 
        /// </summary>
        public FileInfo WatchedFile
        {
            get
            {
                if (watcher == null)
                {
                    return null;
                }

                return new FileInfo(Path.Combine(watcher.Path, watcher.Filter));
            }
        }

        #region ICloneable o
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        public object Clone()
        {
            SyslogConfig config = new SyslogConfig();

            lock (this)
            {
                config.appSetting = this.AppSettings;
                config.FilterModules = this.FilterModules;
                config.Version = this.Version;
                config.ConfigNode = (XmlElement) this.ConfigNode.Clone();
            }

            return config;
        }
        #endregion

        #region IDisposable o
        /// <summary>
        /// 
        /// </summary>
        public void Dispose()
        {
            if (watcher != null)
            {
                watcher.EnableRaisingEvents = false;
                watcher.Dispose();
            }
        }
        #endregion

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        protected void OnConfigurationChanged(object sender, EventArgs e)
        {
            // Cxg𔭐
            ConfigurationChanged(this, EventArgs.Empty);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void watcher_Changed(object sender, FileSystemEventArgs e)
        {
            // Cxg𔭐
            this.OnConfigurationChanged(this, EventArgs.Empty);
        }
    }
}
*/