using System;
using System.Collections;
using System.Diagnostics;

namespace Syslog.Config.EventLog
{
    /// <summary>
    /// app.config \t@CDxXg Ggǂݍ݂܂B
    /// </summary>
    /// <remarks>
    /// <example>
    /// <para>\ZNV̋Lq</para>
    /// <code>
    /// &lt;eventlog&gt;
    ///   &lt;priority facility="User" severity="Notice"&gt;
    ///     &lt;regex source="EntryType"&gt;Info.*&lt;/regex&gt;
    ///   &lt;/priority&gt;
    /// &lt;eventlog&gt;
    /// </code>
    /// </example>
    /// </remarks>
	public class EventLogPriorityEntry
	{
        private Facility facility = Syslog.Facility.User;
        private Severity severity = Syslog.Severity.Notice;
        private ArrayList RegexCollection = new ArrayList();

        /// <summary>
        /// ftHgRXgN^B
        /// </summary>
		public EventLogPriorityEntry()
		{
		}

        /// <summary>
        /// w肷@\\܂B
        /// </summary>
        public string Facility
        {
            get
            {
                return facility.ToString();
            }
            set
            {
                facility = Priority.ParseFacility(value);
            }
        }

        /// <summary>
        /// w肷dx\܂B
        /// </summary>
        public string Severity
        {
            get
            {
                return severity.ToString();
            }
            set
            {
                severity = Priority.ParseSeverity(value);
            }
        }

        /// <summary>
        /// w肵DxKp邩肷鐳K\Xg擾܂B
        /// </summary>
        public ArrayList Regexes
        {
            get
            {
                return RegexCollection;
            }
            set
            {
                RegexCollection = value;
            }
        }

        /// <summary>
        /// w肵DxKp邩ׂ܂B
        /// </summary>
        /// <param name="entry">Dxݒ̓Kp߂邽߂Ƀ}b`CxgGgB</param>
        /// <returns>DxKpꍇ trueB}b`Ȃꍇ falseB</returns>
        public bool IsMatch(EventLogEntry entry)
        {
            // ׂĂ̐K\}b`
            foreach (EventLogRegexEntry regex in this.Regexes)
            {
                // }b`ȂK\ꍇ
                if (!regex.IsMatch(entry))
                {
                    // }b`Ȃ
                    return false;
                }
            }

            // ׂă}b`ꍇ͗DxKpB
            return true;
        }
	}
}
