using System;
using System.Collections;
using System.Collections.Specialized;
using System.Configuration;
using System.Diagnostics;
using System.Xml;

namespace Syslog.Config.EventLog.SectionHandler
{
    /// <summary>
    /// App.config \ZNṼGgǂݎ<see cref="EventLogRegexEntry"/> ̔z <see cref="ArrayList"/> ƂĕԂ܂B
    /// </summary>
    /// <remarks>
    /// <example>
    /// <para>\ZNV̋Lq</para>
    /// <code>
    /// &lt;eventlog&gt;
    ///   &lt;priority facility="User" severity="Notice"&gt;
    ///     &lt;regex source="EntryType"&gt;Info.*&lt;/regex&gt;
    ///   &lt;/priority&gt;
    /// &lt;eventlog&gt;
    /// </code>
    /// </example>
    /// </remarks>
	public class EventLogRegexListSectionHandler : IConfigurationSectionHandler
	{
        private const string regexKey = "regex";
        private const string sourceKey = "source";

        /// <summary>
        /// ftHgRXgN^
        /// </summary>
		public EventLogRegexListSectionHandler()
		{
        }

        #region IConfigurationSectionHandler o
        /// <summary>
        /// \ZNVǂݎ <see cref="EventLogRegexEntry"/> ̔z <see cref="ArrayList"/> Ƃč쐬܂B
        /// </summary>
        /// <param name="parent">Ήe̍\ZNVB</param>
        /// <param name="configContext">\p[^B null QƂłB</param>
        /// <param name="section">\ZNVi[Ă <see cref="XmlNode"/>B</param>
        /// <returns>\ZNV̎qGgǂݎ <see cref="EventLogRegexEntry"/> ̔zB</returns>
        public object Create(object parent, object configContext, XmlNode section)
        {
            ArrayList list = new ArrayList();

            // \ZNṼf[^Ȃꍇ
            if (section == null)
            {
                return list;
            }

            // qm[hꍇ
            if (section.HasChildNodes)
            {
                // ׂĂ̎qm[h܂
                foreach (XmlNode node in section.ChildNodes)
                {
                    // qm[hGgł͂Ȃꍇ
                    if (node.NodeType != XmlNodeType.Element)
                    {
                        // ̃m[hփXLbv
                        continue;
                    }

                    // m[h̃[Jl[ regexKey ł͂Ȃꍇ
                    if (node.LocalName != regexKey)
                    {
                        // ̃m[hփXLbv
                        continue;
                    }

                    // }b`\[X擾܂
                    XmlAttribute SourceAttribute = node.Attributes[sourceKey];
                    // K\p^[擾܂
                    string RegexPattern = node.InnerText;

                    // EventLogRegexEntry 쐬܂
                    EventLogRegexEntry entry = new EventLogRegexEntry();

                    // \[Xw肳Ăꍇ
                    if (SourceAttribute != null)
                    {
                        // \[X̎w擾
                        entry.EventSource = SourceAttribute.Value;
                    }
                    // \[Xw肳ĂȂꍇ
                    else
                    {
                        // \[XƂăCxg\[X𗘗p
                        entry.EventSource = EventLogEventSourceType.Source.ToString();
                    }

                    // K\擾
                    entry.RegexPattern = RegexPattern;

                    // Xgɒǉ
                    list.Add(entry);
                }
            }

            // <see cref="EventLogRegexEntry"/> ̔zԂ
            return list;
        }
        #endregion
    }
}
