using System;
using System.Configuration;
using System.Diagnostics;
using System.Xml;

namespace Syslog.Config.SectionHandler
{
	/// <summary>
	/// App.config \ZNṼAZuW[ǂݎ܂
	/// </summary>
	/// <remarks>
	/// <para>name = AZůȈՖ, path = AZut@C̃pX</para>
	/// <example>
	/// <para>\ZNV̋Lq</para>
    /// <code>
    /// &lt;settings&gt;
    ///   &lt;assembly id="udp-listener" type="Syslog.Listener.UDPListener" name="mlog_listen" publicKeyToken="" culture="ja-JP" version="1.0.0.23778" path="C:\Windows\TEMP\mlog_coll.dll" /&gt;
    /// &lt;settings&gt;
	/// </code>
	/// </example>
	/// </remarks>
	public class AssemblySectionHandler : IConfigurationSectionHandler
	{
        /// <summary>
        /// ftHgRXgN^B
        /// </summary>
		public AssemblySectionHandler()
		{
        }

        #region IConfigurationSectionHandler o
        /// <summary>
        /// \ZNVǂݎ肻̌ʂ <see cref="AssemblyEntryCollection"/> ƂĕԂ܂B
        /// </summary>
        /// <param name="parent">assembly \ZNV̐eZNVB</param>
        /// <param name="configContext">\p[^B null QƂłB</param>
        /// <param name="section">\ZNVi[Ă <see cref="XmlNode"/>B</param>
        /// <returns>\ZNVɃXgꂽAZu\ <see cref="AssemblyEntryCollection"/>B</returns>
        public object Create(object parent, object configContext, XmlNode section)
        {
            // AssemblyEntryCollection ̃CX^X쐬܂
            AssemblyEntryCollection entries = new AssemblyEntryCollection();

            // \ZNV̎qm[h܂
            foreach (XmlNode child in section.ChildNodes)
            {
                // [J assembly ł͂Ȃꍇ
                if (child.LocalName.ToLower() != "assembly")
                {
                    // ̃m[hɏXLbv
                    continue;
                }

                // 1̃AZu\ AssemblyEntry ̃CX^X쐬܂
                AssemblyEntry entry = new AssemblyEntry();

                // qm[hǉRtBOƂ AssemblyEntry ɐݒ肵܂
                entry.Config = child.InnerXml;

                // \ZNV瑮ǂݎ܂
                XmlAttributeCollection Attributes = child.Attributes;
                XmlNode EntryID = Attributes.GetNamedItem("id");
                XmlNode TypeName = Attributes.GetNamedItem("type");
                XmlNode AssemblyName = Attributes.GetNamedItem("name");
                XmlNode KeyToken = Attributes.GetNamedItem("publicKeyToken");
                XmlNode AssemblyCulture = Attributes.GetNamedItem("culture");
                XmlNode AssemblyVersion = Attributes.GetNamedItem("version");
                XmlNode AssemblyPath = Attributes.GetNamedItem("path");

                // IDlw肳ĂȂꍇ
                if (EntryID == null)
                {
                    // AZȕXLbv܂
                    continue;
                }
                // ^w肳ĂȂꍇ
                else if (TypeName == null)
                {
                    // AZȕXLbv܂
                    continue;
                }
                // AZuw肳ĂȂꍇ
                else if (AssemblyName == null)
                {
                    // AZȕXLbv܂
                    continue;
                }

                entry.ID = EntryID.Value;
                entry.Type = TypeName.Value;
                entry.Name = AssemblyName.Value;

                // PublicKeyToken w肳Ăꍇ
                if (KeyToken != null)
                {
                    // PublicKeyToken ǂݎ
                    entry.PublicKeyToken = KeyToken.Value;
                }

                if (AssemblyCulture != null)
                {
                    entry.Culture = AssemblyCulture.Value;
                }

                if (AssemblyVersion != null)
                {
                    entry.Version = AssemblyVersion.Value;
                }

                if (AssemblyPath != null)
                {
                    entry.Path = AssemblyPath.Value;
                }

                // AZȕRNVɒǉ܂
                entries.Add(entry);
            }

            // AZuXg̊SȃRs[Ԃ܂B
            return entries.Clone();
        }

        #endregion
    }
}
