using System;
using System.Collections;
using System.Collections.Specialized;
using System.Configuration;
using System.Xml;

namespace Syslog.Config.SectionHandler
{
	/// <summary>
	/// App.config \ZNṼGgǂݎ <see cref="Hashtable"/> 
	/// ꂼ̃Gg̃f[^W߂ <see cref="Hashtable"/> ̔zƂĕԂ܂B
    /// </summary>
    /// <remarks>
    /// <example>
    /// <para>\ZNV̋Lq</para>
    /// <code>
    /// &lt;settings&gt;
    ///   &lt;group&gt;
    ///     &lt;user name="sa" salt="salt" /&gt;
    ///     &lt;user name="scott" salt="tiger" /&gt;
    ///   &lt;/group&gt;
    /// &lt;settings&gt;
    /// </code>
    /// </example>
    /// </remarks>
	public class CustomValueListSectionHandler : IConfigurationSectionHandler
	{
        /// <summary>
        /// ftHgRXgN^B
        /// </summary>
		public CustomValueListSectionHandler()
		{
        }

        /// <summary>
        /// \ZNVƓǂݎ <see cref="Hashtable"/> ̔z <see cref="ArrayList"/> Ƃč쐬܂B
        /// </summary>
        /// <param name="node">\ZNV <see cref="XmlNode"/> ̕\B</param>
        /// <returns>\ZNV̎qm[hɂ鑮ꂼ <see cref="Hashtable"/> ɂ܂Ƃ
        /// ׂĂ̎qm[h <see cref="Hashtable"/> ̔zƂĕԂ܂B</returns>
        public static object Parse(string node)
        {
            // \ZNVnĂꍇ
            if (node != null || node != String.Empty)
            {
                XmlDocument doc = new XmlDocument();
                XmlDocumentFragment frag = doc.CreateDocumentFragment();
                // \ZNVhLgtOgɓǂݍ
                frag.InnerXml = node;

                // CX^X쐬
                CustomValueListSectionHandler handler = new CustomValueListSectionHandler();
                // Hashtable ̔z쐬
                return handler.Create(null, null, frag);
            }
            // \ZNVnĂȂꍇ
            else
            {
                //  ArrayList Ԃ
                return new CustomValueListSectionHandler().Create(null, null, null);
            }
        }

        #region IConfigurationSectionHandler o
        /// <summary>
        /// \ZNVǂݎqGgƂ <see cref="Hashtable"/> 쐬̔z <see cref="ArrayList"/> ƂĕԂ܂B
        /// </summary>
        /// <param name="parent">Ήe̍\ZNVB</param>
        /// <param name="configContext">\p[^B null QƂłB</param>
        /// <param name="section">\ZNVi[Ă <see cref="XmlNode"/>B</param>
        /// <para>\ZNV̎qGgׂ̏Ċi[ <see cref="Hashtable"/> ̔zB</para>
        public object Create(object parent, object configContext, XmlNode section)
        {
            // TCYς̔z쐬܂
            ArrayList list = new ArrayList();

            //  XmlNode  null ̏ꍇ
            if (section == null)
            {
                // ̂̔zԂ܂
                return list;
            }

            // ZNVɎqGgi[Ăꍇ
            if (section.HasChildNodes)
            {
                // qGgǂݎ Hashtable Ɋi[nh
                CustomValueSectionHandler SectionHandler = new CustomValueSectionHandler();

                // qm[hЂƂ Hashtable ɕϊ
                foreach (XmlNode node in section.ChildNodes)
                {
                    // m[hGgł͂Ȃꍇ
                    if (node.NodeType != XmlNodeType.Element)
                    {
                        // ̃m[hɏXLbv
                        continue;
                    }

                    XmlDocument doc = new XmlDocument();
                    XmlDocumentFragment frag = doc.CreateDocumentFragment();
                    // m[hhLgtOgƂăC|[g
                    frag.AppendChild(doc.ImportNode(node, true));

                    // Ggǂݎ쐬ꂽ Hashtable zɒǉ
                    list.Add((IDictionary) SectionHandler.Create(null, null, frag));
                }
            }

            // zԂ
            return list;
        }
        #endregion
    }
}
