using System;
using System.Collections;
using System.Collections.Specialized;
using System.Configuration;
using System.Xml;

namespace Syslog.Config.SectionHandler
{
	/// <summary>
	/// App.config \ZNṼGgǂݎ <see cref="Hashtable"/> ɂ܂Ƃ߂܂B
    /// </summary>
    /// <remarks>
    /// <example>
    /// <para>\ZNV̋Lq</para>
    /// <code>
    /// &lt;settings&gt;
    ///   &lt;db connection="Provider=SQLOLEDB;Integrated Security=SSPI" table="author" /&gt;
    /// &lt;settings&gt;
    /// </code>
    /// </example>
    /// </remarks>
	public class CustomValueSectionHandler : IConfigurationSectionHandler
	{
        /// <summary>
        /// ftHgRXgN^B
        /// </summary>
		public CustomValueSectionHandler()
		{
        }

        /// <summary>
        /// \ZNVƓǂݎ <see cref="Hashtable"/> 쐬܂B
        /// </summary>
        /// <param name="node">\ZNV <see cref="XmlNode"/> ̕\B</param>
        /// <returns>Gg𕶎ƂĂׂĊi[ <see cref="Hashtable"/>B</returns>
        public static object Parse(string node)
        {
            // \ZNVɒli[Ăꍇ
            if (node != null || node != String.Empty)
            {
                XmlDocument doc = new XmlDocument();
                XmlDocumentFragment frag = doc.CreateDocumentFragment();
                // \ZNVtOgm[hƂēǂݍ
                frag.InnerXml = node;

                // CX^X쐬
                CustomValueSectionHandler handler = new CustomValueSectionHandler();
                // \ZNVǂݎ Hashtable Ԃ
                return handler.Create(null, null, frag);
            }
            // \ZNV̏ꍇ
            else
            {
                // ̃nbVe[uԂ
                return new CustomValueSectionHandler().Create(null, null, null);
            }
        }

        #region IConfigurationSectionHandler o
        /// <summary>
        /// \ZNVǂݎ <see cref="Hashtable"/> Ԃ܂B
        /// </summary>
        /// <param name="parent">Ήe̍\ZNVB</param>
        /// <param name="configContext">\p[^B null QƂłB</param>
        /// <param name="section">\ZNVi[Ă <see cref="XmlNode"/>B</param>
        /// <returns>
        /// <para>\ZNṼGg𕶎ƂĂׂĊi[ <see cref="Hashtable"/>B</para>
        /// <para> <see cref="String.Empty"/> ŃGg̎qm[h擾ł܂B</para></returns>
        public object Create(object parent, object configContext, XmlNode section)
        {
            // Hashtable ɍ\ۑ܂
            Hashtable coll = new Hashtable();

            // \ZNV̏ꍇ
            if (section == null)
            {
                //  Hashtable ̂܂ܕԂ܂
                return coll;
            }

            // \ZNVɎqm[hꍇ
            if (section.HasChildNodes)
            {
                // \ZNV̎qm[hׂď܂
                foreach (XmlNode node in section.ChildNodes)
                {
                    // m[hGgł͂Ȃꍇ
                    if (node.NodeType != XmlNodeType.Element)
                    {
                        // ̃m[hɏXLbv܂
                        continue;
                    }

                    // ݂̃m[ĥɎqm[hftHg̃L[ŕۑ܂
                    coll[String.Empty] = node.InnerXml;

                    // Ggɂ鑮ׂĊi[܂
                    foreach (XmlAttribute attr in node.Attributes)
                    {
                        coll[attr.Name] = attr.Value;
                    }
                }
            }
            // qm[hȂꍇ
            else
            {
                // ݂̃Gg̎qm[hftHg̃L[ŕۑ܂
                coll.Add(String.Empty, section.InnerXml);
            }

            // \ZNVǂݎ Hashtable Ԃ܂
            return coll;
        }
        #endregion
    }
}
