using System;
using System.Collections;
using System.Configuration;
using System.Diagnostics;
using System.Net;
using System.Net.Sockets;
using System.Xml;

namespace Syslog.Config.SectionHandler
{
	/// <summary>
	/// App.config \ZNVǂݎ <see cref="IPEndPoint"/> ̔z쐬܂B
    /// </summary>
    /// <remarks>
    /// <example>
    /// <para>\ZNV̋Lq</para>
    /// <code>
    /// &lt;settings&gt;
    ///   &lt;allow address="0.0.0.0" port="514" /&gt;
    ///   &lt;allow address="::" /&gt;
    /// &lt;settings&gt;
    /// </code>
    /// </example>
    /// </remarks>
	public class IPAddressListSectionHandler : IConfigurationSectionHandler
	{
        // ftHg̃|[gԍ
        private const int SyslogPort = 514;

        /// <summary>
        /// ftHgRXgN^B
        /// </summary>
		public IPAddressListSectionHandler()
		{
        }

        /// <summary>
        /// \ZNVǂݎ <see cref="IPEndPoint"/> ̔z쐬܂B
        /// </summary>
        /// <param name="node">\ZNV <see cref="XmlNode"/> ̕\B</param>
        /// <returns>\ZNVϊ <see cref="IPEndPoint"/> ̔zB</returns>
        public static object Parse(string node)
        {
            // \ZNVɃf[^ꍇ
            if (node != null || node != String.Empty)
            {
                XmlDocument doc = new XmlDocument();
                XmlDocumentFragment frag = doc.CreateDocumentFragment();
                // m[hhLgtOgƂēǂݍ
                frag.InnerXml = node;

                // CX^X쐬
                IPAddressListSectionHandler handler = new IPAddressListSectionHandler();
                // \ZNVIPEndPoint̔zԂ
                return handler.Create(null, null, frag);
            }
            // \ZNṼf[^̏ꍇ
            else
            {
                // ̔z쐬ĕԂ
                return new IPAddressListSectionHandler().Create(null, null, null);
            }
        }

        #region IConfigurationSectionHandler o
        /// <summary>
        /// \ZNVǂݎ <see cref="IPEndPoint"/> ̔z쐬܂B
        /// </summary>
        /// <param name="parent">Ήe̍\ZNVB</param>
        /// <param name="configContext">\p[^B null QƂłB</param>
        /// <param name="section">\ZNVi[Ă <see cref="XmlNode"/>B</param>
        /// <returns>\ZNV̎qGgǂݎϊ <see cref="IPEndPoint"/> ̔zB</returns>
        public object Create(object parent, object configContext, XmlNode section)
        {
            // TCYς̔z쐬
            ArrayList list = new ArrayList();

            // \ZNṼf[^Ȃꍇ
            if (section == null)
            {
                // ̔zԂ
                return list;
            }

            // qm[hꍇ
            if (section.HasChildNodes)
            {
                // qm[hЂƂ
                foreach (XmlNode node in section.ChildNodes)
                {
                    // m[hGgł͂Ȃꍇ
                    if (node.NodeType != XmlNodeType.Element)
                    {
                        // XLbvĎ̃m[hɐi
                        continue;
                    }

                    // ^Õ[J allow ł͂Ȃꍇ
                    if (node.LocalName != "allow")
                    {
                        // XLbvĎ̃m[hɐi
                        continue;
                    }

                    // AhXݒ擾
                    XmlAttribute AddressAttribute = node.Attributes["address"];
                    XmlAttribute PortAttribute = node.Attributes["port"];

                    // AhXȂꍇ
                    if (AddressAttribute == null)
                    {
                        // XLbvĎ̃m[hɐi
                        continue;
                    }

                    try
                    {
                        // IPAhX擾
                        IPAddress Address = IPAddress.Parse(AddressAttribute.Value);
                        // ftHg̃|[gԍ514ɐݒ
                        int Port = SyslogPort;

                        // |[gꍇ
                        if (PortAttribute != null)
                        {
                            // |[gԍݒ
                            Port = Int32.Parse(PortAttribute.Value);
                        }

                        // XGh|Cgǉ
                        list.Add(new IPEndPoint(Address, Port));
                    }
                    catch (Exception e)
                    {
                        Debug.WriteLine(e);

                        // OX[
                        throw e;;
                    }
                }
            }
            // \ZNVɎqm[hЂƂȂꍇ
            else
            {
                // IPv4T|[gĂꍇ
                if (Socket.SupportsIPv4)
                {
                    // ׂĂIPv4AhXSyslog|[gX
                    list.Add(new IPEndPoint(IPAddress.Any, SyslogPort));
                }

                // IPv6T|[gĂꍇ
                if (Socket.SupportsIPv6)
                {
                    // ׂĂIPv6AhXSyslog|[gX
                    list.Add(new IPEndPoint(IPAddress.IPv6Any, SyslogPort));
                }
            }

            // zԂ
            return list;
        }
        #endregion
    }
}
