using System;
using System.Net;
using System.Net.Sockets;
using System.Text.RegularExpressions;

namespace Syslog
{
	/// <summary>
	/// <see cref="SyslogInfo" /> w肳ꂽp^[ɕϊ܂B
	/// </summary>
	public class SyslogFormatter
    {
        private SyslogInfo ReplaceData = null;

        /// <summary>
        /// SyslogInfo ǂݎCX^X쐬܂B
        /// </summary>
        /// <param name="syslog">w肳ꂽK\p^[ɕϊ <see cref="SyslogInfo" />B</param>
		internal protected SyslogFormatter(SyslogInfo syslog)
		{
            ReplaceData = syslog;
		}

        /// <summary>
        /// ǂݍ܂ꂽ <see cref="SyslogInfo" /> w肳ꂽK\p^[ɕϊ܂B
        /// </summary>
        /// <param name="syslog">tH[}bgϊ <see cref="SyslogInfo"/>B</param>
        /// <param name="format">ϊ鐳K\p^[w肵܂B</param>
        /// <returns>wp^[ɕϊꂽB</returns>
        public static string Serialize(SyslogInfo syslog, string format)
        {
            if (syslog == null)
            {
                throw new ArgumentNullException("syslog");
            }

            // SyslogFormatter CX^X쐬
            SyslogFormatter replace = new SyslogFormatter(syslog);

            // w肳ꂽK\p^[ɕϊ
            return replace.ToString(format);
        }

        /// <summary>
        /// <see cref="SyslogInfo"/> 𕶎ɃtH[}bg܂B
        /// </summary>
        /// <returns>ϊꂽB</returns>
        public override string ToString()
        {
            return this.ToString(String.Empty);
        }

        /// <summary>
        /// <see cref="SyslogInfo"/> w肳ꂽK\p^[ɕϊ܂B
        /// </summary>
        /// <remarks>
        /// <example>
        /// K\
        /// <code>{DateTime:yyyy-MM-ddTHH:mm:ss} {SrcAddress}:{SrcAddress:port} {DestAddress:all} {Syslog:PRI}{Syslog:HEADER} {Syslog:MSG}</code>
        /// </example>
        /// </remarks>
        /// <param name="format">ϊ鐳K\p^[w肵܂B</param>
        /// <returns>w肳ꂽp^[ <see cref="SyslogInfo"/> ϊB</returns>
        public string ToString(string format)
        {
            // K\KpIvV
            const RegexOptions RegexOptionSet = RegexOptions.ExplicitCapture | RegexOptions.IgnoreCase | RegexOptions.Singleline;

            string msg = format;

            // K\p^[w肳Ȃꍇ
            if (msg == null || msg == String.Empty)
            {
                msg = "{DateTime} {Syslog}";
            }

            lock (this)
            {
                // ÕzCgXy[X폜
                msg = Regex.Replace(msg, @"^\s+(?=\S)", String.Empty, RegexOptionSet);
                // ̃zCgXy[X폜
                msg = Regex.Replace(msg, @"(?<=\S)\s+$", String.Empty, RegexOptionSet);

                // Mu
                msg = Regex.Replace(msg, @"\{DateTime(:(?<datestyle>.*?))?\}", new MatchEvaluator(this.DateTimeReplace), RegexOptionSet);
                // [JIPAhXu
                msg = Regex.Replace(msg, @"\{(Dest|Destination|Local)(Addr(ess)?|IP)(:(?<ipstyle>.*?))?\}", new MatchEvaluator(this.LocalIPReplace), RegexOptionSet);
                // [gIPAhXu
                msg = Regex.Replace(msg, @"\{(Src|Source|Remote)(Addr(ess)?|IP)(:(?<ipstyle>.*?))?\}", new MatchEvaluator(this.RemoteIPReplace), RegexOptionSet);
                // IvVݒlu
                msg = Regex.Replace(msg, @"\{Option:(?<optionkey>.*?)\}", new MatchEvaluator(this.OptionReplace), RegexOptionSet);
                // SyslogbZ[Wu
                msg = Regex.Replace(msg, @"\{Syslog(:(?<syslogPart>.*?))?\}", new MatchEvaluator(this.SyslogMessageReplace), RegexOptionSet);
            }

            return msg;
        }

        /// <summary>
        /// <para>w肳ꂽK\p^[ɕϊ܂B</para>
        /// <para>K\tH[}bgȏꍇISO 8601tH[}bgɕϊ܂B</para>
        /// </summary>
        /// <param name="m">ϊJX^p^[B</param>
        /// <returns>ϊꂽB</returns>
        protected string DateTimeReplace(Match m)
        {
            // ڍׂȓJX^p^[擾
            Group g = m.Groups["datestyle"];

            // ڍׂȓJX^p^[w肳Ăꍇ
            if (g.Success)
            {
                try
                {
                    // tH[}bgϊ
                    return ReplaceData.ReceivedDateTime.ToString(g.Value);
                }
                catch
                {
                }
            }

            // ISO 8601tH[}bg - 2003-10-01T00:30:30
            return ReplaceData.ReceivedDateTime.ToString("s");
        }

        /// <summary>
        /// >[JAhXw肳ꂽK\p^[ɕϊ܂B
        /// </summary>
        /// <param name="m">ϊɎgpJX^p^[B</param>
        /// <returns>ϊꂽ[JAhXB</returns>
        protected string LocalIPReplace(Match m)
        {
            // [JAhX擾
            IPEndPoint LocalEP = ReplaceData.LocalEndPoint;

            // ڍׂIPAhXJX^p^[擾
            Group g = m.Groups["ipstyle"];

            // ڍׂȃJX^p^[w肳Ăꍇ
            if (g.Success)
            {
                // |[gԍvĂꍇ
                if (g.Value.ToLower() == "port")
                {
                    // |[gԍԂ
                    return LocalEP.Port.ToString();
                }
                // zXgvĂꍇ
                else if(g.Value.ToLower() == "host")
                {
                    // IPAhXtă[JzXgԂ
                    return Dns.GetHostByAddress(ReplaceData.LocalEndPoint.Address).HostName;
                }
                // AhXƃ|[gԍvĂꍇ
                else if (g.Value.ToLower() == "all")
                {
                    // IPv6AhXpĂꍇ
                    if (LocalEP.AddressFamily == AddressFamily.InterNetworkV6)
                    {
                        // ʂŃAhXĂ|[gԍǉ
                        return String.Format("[{0}]:{1}", LocalEP.Address.ToString(), LocalEP.Port);
                    }
                        // IPv4AhXpĂꍇ
                    else
                    {
                        // AhXƃ|[gԍԂ
                        return String.Format("{0}:{1}", LocalEP.Address.ToString(), LocalEP.Port);
                    }
                }
            }

            // ftHg̃AhX\Lgp
            return LocalEP.Address.ToString();
        }

        /// <summary>
        /// [gAhXw肳ꂽK\p^[ɕϊ܂B
        /// </summary>
        /// <param name="m">ϊɎgpJX^p^[B</param>
        /// <returns>ϊꂽ[gAhXB</returns>
        protected string RemoteIPReplace(Match m)
        {
            // [gAhX擾
            IPEndPoint RemoteEP = ReplaceData.RemoteEndPoint;

            // ڍׂIPAhXJX^p^[擾
            Group g = m.Groups["ipstyle"];

            // ڍׂȃJX^p^[w肳Ăꍇ
            if (g.Success)
            {
                // |[gԍvĂꍇ
                if (g.Value.ToLower() == "port")
                {
                    // |[gԍԂ
                    return RemoteEP.Port.ToString();
                }
                // zXgvĂꍇ
                else if (g.Value.ToLower() == "host")
                {
                    // IPAhXtă[gzXgԂ
                    return Dns.GetHostByAddress(ReplaceData.RemoteEndPoint.Address).HostName;
                }
                // AhXƃ|[gԍvĂꍇ
                else if (g.Value.ToLower() == "all")
                {
                    // IPv6AhXw肳Ăꍇ
                    if (RemoteEP.AddressFamily == AddressFamily.InterNetworkV6)
                    {
                        // ʂŃAhXĂ|[gԍǉ
                        return String.Format("[{0}]:{1}", RemoteEP.Address.ToString(), RemoteEP.Port);
                    }
                    else
                    {
                        // AhXƃ|[gԍԂ
                        return String.Format("{0}:{1}", RemoteEP.Address.ToString(), RemoteEP.Port);
                    }
                }
            }

            // ftHg̃AhX\Lgp
            return ReplaceData.RemoteEndPoint.Address.ToString();
        }

        /// <summary>
        /// IvVl𕶎ɃtH[}bg܂B
        /// </summary>
        /// <param name="m">ϊɎgpJX^p^[B</param>
        /// <returns>w肳ꂽIvVl̕\B</returns>
        protected string OptionReplace(Match m)
        {
            // IvVl擾
            Group g = m.Groups["optionkey"];

            // IvVlw肳Ăꍇ
            if (g.Success)
            {
                // w肳ꂽIvVl݂邩mF
                if (ReplaceData.OptionList.Contains(g.Value))
                {
                    // IvVlԂ
                    return ReplaceData.OptionList[g.Value].ToString();
                }
            }

            // 󕶎Ԃ
            return String.Empty;
        }

        /// <summary>
        /// SyslogbZ[W̓p[g𕶎ƂĎ擾܂B
        /// </summary>
        /// <param name="m">ϊɎgpJX^p^[B</param>
        /// <returns>SyslogbZ[W̓̃p[g̕\B</returns>
        protected string SyslogMessageReplace(Match m)
        {
            // ڍׂȃJX^p^[擾
            Group g = m.Groups["syslogPart"];

            if (g.Success)
            {
                SyslogMessage Msg = ReplaceData.Message;

                #region SyslogbZ[W̓p[gɒu
                // SyslogbZ[W̃p[goĕԂ
                switch (g.Value.ToLower())
                {
                    case "pri":
                    {
                        return Msg.PRI;
                    }
                    case "header":
                    {
                        return Msg.HEADER;
                    }
                    case "msg":
                    {
                        return Msg.MSG;
                    }
                    case "priority":
                    {
                        return Msg.Priority.ToString();
                    }
                    case "facility":
                    {
                        return Msg.Facility.ToString();
                    }
                    case "severity":
                    {
                        return Msg.Severity.ToString();
                    }
                    case "timestamp":
                    {
                        return Msg.GetTimeStamp();
                    }
                    case "hostname":
                    {
                        return Msg.Hostname;
                    }
                    case "tag":
                    {
                        return Msg.TAG;
                    }
                    case "content":
                    {
                        return Msg.CONTENT;
                    }
                    default:
                    {
                        // Yp[gȂꍇ͋󕶎Ԃ
                        return String.Empty;
                    }
                }
                #endregion
            }

            // SyslogbZ[WŜԂ
            return ReplaceData.Message.ToString();
        }
	}
}
