using System;
using System.Collections;
using System.Collections.Specialized;
using System.Net;

namespace Syslog
{
	/// <summary>
	/// Syslog bZ[W𓝍Iɕ\܂B
    /// </summary>
    [Serializable]
	public class SyslogInfo : ICloneable
	{
        private SyslogMessage message = null;
        private IPEndPoint localEndPoint = null;
        private IPEndPoint remoteEndPoint = null;
        private DateTime receivedDateTime = DateTime.Now;
        private HybridDictionary optionList = new HybridDictionary(true);

        /// <summary>
        /// ftHgRXgN^B
        /// </summary>
		public SyslogInfo()
		{
		}

        /// <summary>
        /// RXgN^B<see cref="SyslogPacket"/> ǂݍŃCX^X܂B
        /// </summary>
        /// <param name="packet"></param>
        public SyslogInfo(SyslogPacket packet)
        {
            this.LocalEndPoint = packet.LocalEndPoint;
            this.RemoteEndPoint = packet.RemoteEndPoint;
            this.ReceivedDateTime = packet.ReceivedDateTime;
            this.Message = new SyslogMessage(packet);
            this.OptionList = packet.Option;
        }

        /// <summary>
        /// <see cref="SyslogMessage"/> 擾܂͐ݒ肵܂B
        /// </summary>
        public SyslogMessage Message
        {
            get
            {
                return message;
            }
            set
            {
                message = value;
            }
        }

        /// <summary>
        /// bZ[WMC^[tFCX\ <see cref="IPEndPoint"/>B
        /// </summary>
        public IPEndPoint LocalEndPoint
        {
            get
            {
                return localEndPoint;
            }
            set
            {
                localEndPoint = value;
            }
        }

        /// <summary>
        /// bZ[W𑗐MzXg\ <see cref="IPEndPoint"/>B
        /// </summary>
        public IPEndPoint RemoteEndPoint
        {
            get
            {
                return remoteEndPoint;
            }
            set
            {
                remoteEndPoint = value;
            }
        }

        /// <summary>
        /// bZ[WM擾܂͐ݒ肵܂B
        /// </summary>
        public DateTime ReceivedDateTime
        {
            get
            {
                return receivedDateTime;
            }
            set
            {
                receivedDateTime = value;
            }
        }

        /// <summary>
        /// bZ[WɊ֌WǉIȃIvVl̃Xg擾܂͐ݒ肵܂
        /// </summary>
        public IDictionary OptionList
        {
            get
            {
                return (IDictionary) optionList;
            }
            set
            {
                optionList = (HybridDictionary) value;
            }
        }

        #region ICloneable o
        /// <summary>
        /// IuWFNg̊SȃRs[쐬܂B
        /// </summary>
        /// <returns></returns>
        object ICloneable.Clone()
        {
            return this.Clone();
        }

        /// <summary>
        /// IuWFNg̊SȃRs[쐬܂B
        /// </summary>
        /// <returns>
        /// OptionList ܂߂Sȏڍ׃Rs[ł
        /// </returns>
        public virtual SyslogInfo Clone()
        {
            SyslogInfo clone = (SyslogInfo) this.MemberwiseClone();

            // [JGh|Cg̃Rs[
            if (this.LocalEndPoint != null && this.LocalEndPoint.Address != null)
                clone.LocalEndPoint = new IPEndPoint(this.LocalEndPoint.Address, this.LocalEndPoint.Port);

            // [gGh|Cg̃Rs[
            if (this.RemoteEndPoint != null && this.RemoteEndPoint.Address != null)
                clone.RemoteEndPoint = new IPEndPoint(this.RemoteEndPoint.Address, this.RemoteEndPoint.Port);

            // SyslogbZ[W̏ڍׂȃRs[
            if (this.Message != null)
                clone.Message = (SyslogMessage) this.Message.Clone();

            // IvVXg̏ڍׂȃRs[
            IDictionary Options = this.OptionList;

            if (Options != null)
            {
                // IvVlXgbN
                lock (Options.SyncRoot)
                {
                    const string CloneInterface = "ICloneable";

                    // Rs[ꂽIvV
                    IDictionary CopyOptions = (IDictionary) new HybridDictionary(Options.Count, true);

                    foreach (object obj in Options.Keys)
                    {
                        object OptionKey = obj;
                        object OptionValue = Options[obj];

                        // L[ɐݒ肳ĂIuWFNg ICloneable C^[tFCXT|[gĂ邩𒲂ׂ
                        if (obj.GetType().GetInterface(CloneInterface, true) != null)
                        {
                            // L[ IuWFNg̏ڍ׃Rs[쐬ĊȈՃRs[u
                            OptionKey = ((ICloneable) obj).Clone();
                        }

                        if (OptionValue != null)
                        {
                            // IvVl̃IuWFNg ICloneable C^[tFCXT|[gĂ邩ׂ
                            if (OptionValue.GetType().GetInterface(CloneInterface, true) != null)
                            {
                                // vfIuWFNg̏ڍ׃Rs[쐬ĊȈՃRs[u
                                OptionValue = ((ICloneable) OptionValue).Clone();
                            }
                        }

                        // Rs[ꂽIvVRNVɒǉ
                        CopyOptions.Add(OptionKey, OptionValue);
                    }

                    // Rs[ꂽIvVXgݒ肷
                    clone.OptionList = CopyOptions;
                }
            }

            // SȃRs[Ԃ
            return clone;
        }
        #endregion

        /// <summary>
        /// ȈՃRs[܂͊SȃRs[쐬܂B
        /// </summary>
        /// <param name="deep">SȃRs[w肵܂B</param>
        /// <returns>CX^XRs[VCX^XB</returns>
        public virtual object Clone(bool deep)
        {
            if (deep)
                return this.Clone();
            else
                return this.MemberwiseClone();
        }
    }
}
