using System;
using System.Collections;
using System.Collections.Specialized;
using System.Configuration;
using System.Diagnostics;
using System.Net;
using System.Text;
using Syslog.Config;

namespace Syslog
{
	/// <summary>
	/// \Pbg C^[tF[XM UDP pPbg\܂B
	/// </summary>
	/// <remarks>
	/// <c>SyslogPacket</c> NX́A\Pbg C^[tF[XM UDP pPbg̃f[^A
	/// MC^[tF[X̏񂨂юMԂi[܂B
	/// </remarks>
	public class SyslogPacket
	{
        private byte[] packetData = null;
        private IPEndPoint localEndPoint = null;
        private IPEndPoint remoteEndPoint = null;
        private DateTime receivedDateTime = DateTime.Now;
        // ftHg̕GR[fBO𗘗p
        private Encoding encoding = DefaultEncoding.GetDefaultEncoding();
        private HybridDictionary optionList = new HybridDictionary(true);

        /// <summary>
        /// <c>SyslogPacket</c> NX̐VCX^X܂B
        /// </summary>
        public SyslogPacket()
        {
        }

        /// <summary>
        /// pPbg f[^擾܂B
        /// </summary>
        /// <remarks>
        /// UDP pPbg f[^oCgz񂩂\t@CŎw肳ꂽR[h𗘗p <see cref="System.String"/> ɕϊ܂B
        /// ftHg̕R[h euc-jp łB
        /// </remarks>
        /// <returns>UDP pPbg f[^̕B</returns>
        public string GetPacketString()
        {
            if (this.PacketData != null)
            {
                // GR[hݒ擾 System.String ɕϊ
                return this.Encode.GetString(this.PacketData);
            }
            else
            {
                return null;
            }
        }

        /// <summary>
        /// pPbg f[^ <paramref name="packet"/> Œu܂B
        /// </summary>
        /// <remarks>
        /// <paramref name="packetData"/> \t@CŎw肳ꂽR[h@oCgzɕϊAUDP pPbg f[^ƒu܂B
        /// ftHg̕R[h euc-jp łB
        /// </remarks>
        /// <param name="packetData">UDP pPbg f[^u镶B</param>
        public void SetPacketString(string packetData)
        {
            // GR[hݒ擾 zϊ...
            this.SetPacketString(packetData, this.Encode);
        }

        /// <summary>
        /// <paramref name="packet"/>  <paramref name="encoding"/> Ŏw肵R[hɕϊÃoCgzUDP pPbg f[^ƒu܂B
        /// </summary>
        /// <remarks>
        /// <paramref name="packet"/> oCgzɕϊAUDP pPbg f[^ƒu܂B
        /// </remarks>
        /// <param name="packetData">UDP pPbg f[^u镶B</param>
        /// <param name="encoding">oCgzɂ镶ϊ镶R[h</param>
        public void SetPacketString(string packetData, Encoding encoding)
        {
            // Unicode zϊ...
            if (encoding != null)
                this.PacketData = encoding.GetBytes(packetData);
        }

        /// <summary>
        /// pPbg f[^oCgẑ܂܎擾܂B
        /// </summary>
        /// <value>MpPbg̃oCgzB</value>
        public byte[] PacketData
        {
            get
            {
                return packetData;
            }
            set
            {
                packetData = value;
            }
        }

        /// <summary>
        /// MC^[tF[X擾܂B
        /// </summary>
        /// <remarks>
        /// UDP pPbgMC^[tF[X̏܂ <see cref="System.Net.IPEndPoint"/> 擾܂B
        /// </remarks>
        /// <value>pPbgMGh|Cgi[ <see cref="System.Net.IPEndPoint"/> CX^XB</value>
        public IPEndPoint LocalEndPoint
        {
            get
            {
                return localEndPoint;
            }
            set
            {
                localEndPoint = value;
            }
        }

        /// <summary>
        /// pPbg̑M擾܂B
        /// </summary>
        /// <remarks>
        /// UDP pPbg𑗐MzXg̏܂ <see cref="System.Net.IPEndPoint"/> 擾܂B
        /// </remarks>
        /// <value>pPbg𑗐MGh|Cgi[ <see cref="System.Net.IPEndPoint"/> CX^XB</value>
        public IPEndPoint RemoteEndPoint
        {
            get
            {
                return remoteEndPoint;
            }
            set
            {
                remoteEndPoint = value;
            }
        }

        /// <summary>
        /// pPbgM擾܂B
        /// </summary>
        /// <value>pPbgMi[ <see cref="System.DateTime"/> CX^XB</value>
        public DateTime ReceivedDateTime
        {
            get
            {
                return receivedDateTime;
            }
            set
            {
                receivedDateTime = value;
            }
        }

        /// <summary>
        /// pPbgf[^̕R[h擾܂͐ݒ肵܂B
        /// </summary>
        public Encoding Encode
        {
            get
            {
                return this.encoding;
            }
            set
            {
                this.encoding = value;
            }
        }

        /// <summary>
        /// ǉIȃf[^擾܂B
        /// </summary>
        /// <remarks>
        /// JX^ tB^płǉIȃf[^ۑ <see cref="System.Collections.IDictionary"/> 擾܂͐ݒ肵܂B
        /// </remarks>
        /// <value>ǉIȃf[^i[ <see cref="System.Collections.IDictionary"/> CX^XB</value>
        /// <exception cref="System.ArgumentNullException">Null QƁB</exception>
        public IDictionary Option
        {
            get
            {
                return (IDictionary) optionList;
            }
            set
            {
                if (value != null)
                    optionList = (HybridDictionary) value;
                else
                    throw new ArgumentNullException("Option");
            }
        }
	}
}
