using System;
using System.Collections;
using System.Collections.Specialized;
using System.Configuration;
using System.Diagnostics;
using System.Net;
using System.Text;
using Syslog.Listener;
using Syslog.Config.SectionHandler;

namespace Syslog.Listener.Filter
{
	/// <summary>
	/// Syslog pPbg̃\[XAhXɊÂ Syslog bZ[W̓ǂݎɗp镶GR[fBOI܂B
	/// </summary>
	/// <remarks>
	///     <para>app.config ݒB</para>
	///     <code>&lt;select source="127.0.0.1" encoding="shift_jis" /&gt;</code>
	///     <list type="table">
	///         <listheader>
	///             <term></term>
	///             <description>ݒl</description>
    ///         </listheader>
    ///         <item>
    ///             <term>source</term>
    ///             <description>GR[fBOύX Syslog bZ[W̑MIPAhXBzXg͗pł܂B</description>
    ///         </item>
    ///         <item>
    ///             <term>encoding</term>
    ///             <description>Syslog bZ[W̓ǂݎɗp镶GR[fBOB</description>
    ///         </item>
	///     </list>
	/// </remarks>
	public class EncodingSelector : ISyslogListenerFilter
	{
        private const string DisplayName = "Syslog Message Encoding Selector";
        private const string ConfigSourceAddressKey = "source";
        private const string ConfigEncodingKey = "encoding";

        private ArrayList EncodingList = new ArrayList();

        /// <summary>
        /// ftHgRXgN^
        /// </summary>
		public EncodingSelector()
		{
        }

        #region ISyslogListenerFilter o
        /// <summary>
        /// tB^ĕGR[fBȌ𐮂܂B
        /// </summary>
        /// <param name="FilterEvent">tB^OsCxgfQ[gi[ <see cref="ListenerFilterEvent"/>B</param>
        /// <param name="config">app.config JX^RtBO[Vm[hB</param>
        public void Init(ListenerFilterEvent FilterEvent, string config)
        {
            // JX^ݒǂݎ
            this.LoadEncodingList(config);

            // MG[`FbNOɃtB^Kp
            FilterEvent.Receiving += new ReceivedEventHandler(FilterEvent_Receiving);
        }

        /// <summary>
        /// EncodingSelector ̃thԂ܂
        /// </summary>
        public string Name
        {
            get
            {
                return DisplayName;
            }
        }

        #endregion

        #region IDisposable o
        /// <summary>
        /// \[X܂B
        /// </summary>
        public void Dispose()
        {
        }
        #endregion

        /// <summary>
        /// Syslog pPbg̑M`FbNėp镶GR[fBOύX܂
        /// </summary>
        /// <param name="sender">SyslogpPbgM <see cref="ISyslogListener"/>B</param>
        /// <param name="e">SyslogpPbgf[^i[ <see cref="ReceivedEventArgs"/>B</param>
        /// <returns>pPbg̏𑱍sꍇ trueB𒆎~ꍇ falseB</returns>
        private bool FilterEvent_Receiving(object sender, ReceivedEventArgs e)
        {
            // ׂĂ̕GR[fBOw`FbN
            foreach (IDictionary select in EncodingList)
            {
                IPAddress SourceAddress = (IPAddress) select[ConfigSourceAddressKey];
                Encoding SelectEncoding = (Encoding) select[ConfigEncodingKey];

                // \[XIPAhXMpPbgƈvꍇ
                if (SourceAddress.Equals(e.Packet.RemoteEndPoint.Address))
                {
                    // VGR[fBOݒ肷
                    e.Packet.Encode = SelectEncoding;
                }
            }

            // ׂẴpPbg̏𑱍s
            return true;
        }

        /// <summary>
        /// JX^ݒǂݎĕGR[fBOwł悤ɂ܂B
        /// </summary>
        /// <param name="config">app.config JX^RtBO[VB</param>
        private void LoadEncodingList(string config)
        {
            // JX^ݒǂݎ肷ׂĂ̕GR[fBOw擾
            foreach (Hashtable select in (ArrayList) CustomValueListSectionHandler.Parse(config))
            {
                // \[XIPAhXƕGR[fBOw肳Ăꍇ
                if (select.Contains(ConfigSourceAddressKey) && select.Contains(ConfigEncodingKey))
                {
                    // \[XIPAhXw擾
                    string SourceValue = select[ConfigSourceAddressKey].ToString().Trim();
                    // GR[fBOw擾
                    string EncodingValue = select[ConfigEncodingKey].ToString().Trim();

                    IPAddress SourceAddress = null;
                    Encoding SelectEncoding = null;

                    try
                    {
                        // \[XIPAhX擾
                        SourceAddress = IPAddress.Parse(SourceValue);
                    }
                    // \[XIPAhXIPAhXł͂Ȃꍇ
                    catch (FormatException)
                    {
                        // DNSŖOă\[XIPAhX擾
                        SourceAddress = Dns.GetHostByName(SourceValue).AddressList[0];
                    }

                    // GR[fBOݒ擾
                    SelectEncoding = Encoding.GetEncoding(EncodingValue);

                    // ݒlyA쐬
                    ListDictionary DetailList = new ListDictionary();
                    // \[XIPAhXǉ
                    DetailList.Add(ConfigSourceAddressKey, SourceAddress);
                    // GR[fBOݒǉ
                    DetailList.Add(ConfigEncodingKey, SelectEncoding);

                    // }b`R[hݒ胊Xgɒǉ
                    EncodingList.Add(DetailList);
                }
            }
        }
    }
}
