using System;
using System.Collections;
using System.Diagnostics;
using System.Net;
using Syslog.Config.SectionHandler;

namespace Syslog.Relay.Filter
{
	/// <summary>
    /// SyslogpPbg̃\[XAhXɃtB^O܂B
    /// </summary>
    /// <remarks>g[XXCb`ɂătB^OpPbgg[Xo͂邩ł܂B
    /// <list type="table">
    /// <listheader>
    ///     <term>g[X x</term>
    ///     <description>\t@Cł̒l</description>
    /// </listheader>
    /// <item>
    ///     <term>Off</term>
    ///     <description>0</description>
    /// </item>
    /// <item>
    ///     <term>Info - tB^Og[Xo</term>
    ///     <description>3</description>
    /// </item>
    /// <item>
    ///     <term>Verbose - tB^OpPbg̓eg[Xo</term>
    ///     <description>4</description>
    /// </item>
    /// </list>
    /// </remarks>
    /// <example>
    /// <code>
    /// &lt;system.diagnostics&gt;
    ///  &lt;switches&gt;
    ///   &lt;add name="SourceAddressFilterTraceSwitch" value="3" /&gt;
    ///  &lt;/switches&gt;
    /// &lt;/system.diagnostics&gt;</code>
    /// </example>
	public class SourceAddressFilter : ISyslogRelayFilter
    {
        private static TraceSwitch SourceTracingSwitch = new TraceSwitch("SourceAddressFilterTraceSwitch", "SourceAddress Filter ŃtB^OꂽpPbg̏@g[Xo͂邩肵܂");

        private IList AddressList = null;

        /// <summary>
        /// ftHgRXgN^B
        /// </summary>
		public SourceAddressFilter()
		{
        }

        #region ISyslogRelayFilter o
        /// <summary>
        /// CxgfQ[gZbgAbvtB^܂B
        /// </summary>
        /// <param name="filterEvent">CxgfQ[g܂ RelayFilterEventB</param>
        /// <param name="config">app.config JX^RtBO[Vm[hB</param>
        public void Init(RelayFilterEvent filterEvent, string config)
        {
            // \[XAhXXg擾
            AddressList = (IList) IPAddressListSectionHandler.Parse(config);

            // [eBOCxgɐڑ
            filterEvent.Routing += new RoutingEventHandler(FilterEvent_Routing);
        }

        /// <summary>
        /// SourceAddressFilter ̃thłB
        /// </summary>
        public string Name
        {
            get
            {
                return "Source Address Routing Filter";
            }
        }
        #endregion

        #region IDisposable o
        /// <summary>
        /// CX^XێĂ郊\[XJ܂B
        /// </summary>
        public void Dispose()
        {
        }
        #endregion

        /// <summary>
        /// [eBOCxgtB^O܂B
        /// </summary>
        /// <param name="sender">Cxg̔łB</param>
        /// <param name="e">tB^ǑɗpłCxgf[^łB</param>
        /// <returns>㑱̃W[ŏ SyslogInfoB null QƂԂƌ㑱̏𒆎~܂B</returns>
        private SyslogInfo FilterEvent_Routing(object sender, RoutingEventArgs e)
        {
            // \[XAhXXgƏƍ
            foreach (IPEndPoint endPoint in AddressList)
            {
                // ꂽ\[XAhXƎMSyslogpPbg̃\[XƃAhXvꍇ
                if (e.Syslog.RemoteEndPoint.ToString() == endPoint.ToString())
                {
                    // 㑱̃W[֏n
                    return e.Syslog;
                }
            }
            
            // g[Xx Info ȏ̏ꍇ
            if (SourceTracingSwitch.TraceInfo)
            {
                Trace.Indent();
                Trace.WriteLine(String.Format("{0}, Message Filtered on SourceAddressFilter.", e.Syslog.RemoteEndPoint.ToString()), "Syslog.Relay.SourceAddressFilter");

                if (SourceTracingSwitch.TraceVerbose)
                {
                    Trace.Indent();
                    Trace.WriteLine(e.Syslog.Message.ToString(), "Syslog.Relay.SourceAddressFilter");
                    Trace.Unindent();
                }

                Trace.Unindent();
            }

            // ꂽ\[XAhXXgƈvȂꍇ͌㑱̏𒆎~
            return null;
        }
    }
}
