using System;
using System.Collections;
using System.Configuration;
using System.Diagnostics;
using Syslog.Collector;
using Syslog.Config;

namespace Syslog.Relay
{
	/// <summary>
	/// Syslog Listener Controler ŎM Syslog pPbgW[փ[eBO܂B
	/// </summary>
	public class RelayController : IDisposable
	{
        // SyslogpPbĝ߂̃vOCW[ݒ擾邽߂̃L[
        private const string ConfigModuleSection = "syslogConfig/relay/plugin";
        // [eBOɃOtB^郂W[̐ݒ擾邽߂̃L[
        private const string ConfigFilterSection = "syslogConfig/relay/filters";
        // ftHgRN^[eBOvOCpvOCID
        private const string CollectorPluginID = "##collector";

        private IDictionary PluginList = new Hashtable();
        private IDictionary FilterList = new Hashtable();
        private RelayFilterEvent FilterEvent = new RelayFilterEvent();

        /// <summary>
        /// ftHgRXgN^B
        /// </summary>
        /// <exception cref="ModuleLoadingException">ISyslogRelayPlugin W[܂ ISyslogRelayFilter tB^ W[̃[hɃG[ꍇɃX[܂B</exception>
		public RelayController()
        {
            // ftHg̃RN^[eBO vOCǉ
            PluginList[CollectorPluginID] = new CollectorRoutingPlugin(String.Empty);
            
            // vOCo^Xg擾
            AssemblyEntryCollection entries = (AssemblyEntryCollection) ConfigurationSettings.GetConfig(ConfigModuleSection);

            // vOCw肳ĂȂꍇ
            if (entries == null)
            {
                // ̃vOCo^Xg쐬
                entries = new AssemblyEntryCollection(0);
            }

            // App.config Ŏw肳ꂽvOC[h
            foreach (AssemblyEntry entry in entries)
            {
                try
                {
                    // vOC̃CX^Xǉݒnč쐬
                    ISyslogRelayPlugin Plugin = (ISyslogRelayPlugin) entry.CreateInstance(entry.Config);

                    Debug.Assert(Plugin != null, "vOC̃[hɎs܂");

                    if (Plugin != null)
                    {
                        // vOCXgɃCX^Xǉ
                        PluginList[entry.ID] = Plugin;
                    }
                    else
                    {
                        // OX[
                        throw new ModuleLoadingException(String.Format("[{0}] Xi W[̃[hɎs܂", entry.ID));
                    }
                }
                catch (Exception e)
                {
                    Debug.Assert(false, "[vOCW[̓ǂݍ݂Ɏs܂", e.ToString());
                    Trace.WriteLine("[vOCW[̓ǂݍ݂Ɏs܂!", "Syslog.Relay.RelayController");

                    // OX[
                    throw e;
                }
            }

            // [eBOtB^o^Xg擾
            AssemblyEntryCollection filterEntries = (AssemblyEntryCollection) ConfigurationSettings.GetConfig(ConfigFilterSection);

            // [eBOtB^w肳Ȃꍇ
            if (filterEntries == null)
            {
                // ̃[eBOtB^o^Xg쐬
                filterEntries = new AssemblyEntryCollection(0);
            }

            // App.config Ŏw肳ꂽ[eBOtB^[h
            foreach (AssemblyEntry entry in filterEntries)
            {
                try
                {
                    // tB^̃CX^X쐬
                    ISyslogRelayFilter Filter = (ISyslogRelayFilter) entry.CreateInstance();

                    Debug.Assert(Filter != null, "tB^̃[hɎs܂");

                    if (Filter != null)
                    {
                        // tB^ɃCxgfQ[gƃ[U\ݒnď
                        Filter.Init(FilterEvent, entry.Config);

                        // [eBOtB^o^XgɃCX^Xǉ
                        FilterList[entry.ID] = Filter;
                    }
                    else
                    {
                        // OX[
                        throw new ModuleLoadingException(String.Format("[{0}] Xi W[̃[hɎs܂", entry.ID));
                    }
                }
                catch (Exception e)
                {
                    Debug.Assert(false, "[tB^ǂݍ݂Ɏs܂", e.ToString());
                    Trace.WriteLine("[tB^̓ǂݍ݂Ɏs܂!", "Syslog.Relay.RelayController");
                    
                    // OX[
                    throw e;
                }
            }
		}

        /// <summary>
        /// SyslogpPbgɃtB^KpW[փ[eBOs܂B
        /// </summary>
        /// <param name="packet">SyslogbZ[WJvZ SyslogPacketB</param>
        public void Relay(SyslogPacket packet)
        {
            // SyslogPacket  SyslogInfo ̃CX^X쐬܂
            SyslogInfo syslogInfo = new SyslogInfo(packet);

            // pPbgW[ŏ܂
            foreach (string pluginKey in PluginList.Keys)
            {
                SyslogInfo info = syslogInfo;
                // Xg珈W[o܂
                ISyslogRelayPlugin plugin = (ISyslogRelayPlugin) PluginList[pluginKey];

                try
                {
                    // [hĂtB^ɃCxg𑗂SyslogpPbg̃tB^Os܂
                    info = FilterEvent.OnRouting(plugin, new RoutingEventArgs(pluginKey, plugin, info));

                    // tB^SyslogpPbgtB^OȂꍇ
                    if (info != null)
                    {
                        // [eBOW[ɏn܂
                        plugin.Process(info);
                    }
                    // tB^SyslogpPbgtB^Oꂽꍇ
                    else
                    {
                        // ̃[eBOW[̏𑱍s
                        continue;
                    }
                }
                catch (Exception e)
                {
                    Debug.Assert(false, "bZ[W̃[ɃG[܂", e.ToString());

                    Trace.WriteLine("bZ[W̃[ɃG[܂!.", "Syslog.Relay.RelayController");
                    Trace.Indent();
                    Trace.WriteLine(e.ToString(), "Syslog.Relay.RelayController");
                    Trace.Unindent();
                }
            }
        }

        /// <summary>
        /// W[tB^W[ȂǂJ܂B
        /// </summary>
        public void Close()
        {
            this.Dispose();
        }

        #region IDisposable o
        /// <summary>
        /// CX^XێĂ郊\[X܂B
        /// </summary>
        public void Dispose()
        {
            // [eBOW[
            foreach (ISyslogRelayPlugin plugin in PluginList.Values)
            {
                try
                {
                    // W[̃\[X
                    plugin.Dispose();
                }
                catch (Exception e)
                {
                    Debug.Assert(false, "[ vOC̃\[XɃG[܂", e.ToString());
                }
            }

            // tB^W[
            foreach (ISyslogRelayFilter filter in FilterList.Values)
            {
                try
                {
                    // tB^W[̃\[X
                    filter.Dispose();
                }
                catch (Exception e)
                {
                    Debug.Assert(false, "[ tB^̃\[XɃG[܂", e.ToString());
                }
            }

            // [eBOW[XgNA
            PluginList.Clear();
            // tB^W[XgNA
            FilterList.Clear();
        }
        #endregion
    }
}
