using System;
using System.CodeDom.Compiler;
using System.Configuration;
using System.Collections;
using System.Collections.Specialized;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Imaging;
using System.Globalization;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.ServiceProcess;
using System.Reflection;
using System.Runtime.Remoting;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading;
using System.Web;
using System.Xml;
using System.Xml.Schema;
using System.Xml.Serialization;
using Syslog;
using Syslog.Config;
using Syslog.Config.EventLog;
using Syslog.Config.EventLog.SectionHandler;
using Syslog.Config.SectionHandler;
using Syslog.Listener;
using Syslog.Relay;
using Syslog.Collector;
using Syslog.Collector.Writer;

namespace Syslog.Test
{
	/// <summary>
	/// Main ̊Tv̐łB
	/// </summary>
	class SocketTester
	{
        public static Queue ReceiveQueue = new Queue();
        private static AutoResetEvent WaitEvent = new AutoResetEvent(false);
        private static Regex PritableReplacing = new Regex(@"[/\-+]", RegexOptions.Compiled | RegexOptions.CultureInvariant | RegexOptions.ExplicitCapture | RegexOptions.Singleline);

        private delegate void AsyncHello();

		/// <summary>
		/// AvP[ṼC Gg |CgłB
		/// </summary>
        [STAThread]
        static void Main(string[] args)
        {
            EventView();
        }

        static void EventView()
        {
            EventLog[] Events = EventLog.GetEventLogs();

            Console.WriteLine(Events[2].Entries[Events[2].Entries.Count - 1].Index);

            foreach (EventLogEntry entry in Events[2].Entries)
            {
                Console.WriteLine(entry.Index.ToString());
            }

            Debugger.Break();
        }

        static void ConfigTest()
        {
            Console.WriteLine(Priority.ParseFacility("kern"));
            Console.WriteLine(Priority.ParseSeverity("error"));

            XmlDocument x = new XmlDocument();
            XmlDocumentFragment doc = x.CreateDocumentFragment();
            doc.InnerXml = "<simpleFileWriter rotation=\"day\" outputPath=\".\" /><simpleFileWriter rotation=\"day\" outputPath=\".\" />";
            doc.InnerXml = @"<allow priority=""1"" facility=""1"" target=""keys"" /><allow priority=""10"" facility=""5"" target=""debug"" />";
            x.AppendChild(x.CreateElement("assembly"));
            //x.FirstChild.AppendChild(doc);

            CustomValueListSectionHandler tag = new CustomValueListSectionHandler();
            object o = tag.Create(null, null, (XmlNode) doc);
            IDictionary config = (IDictionary) CustomValueSectionHandler.Parse(doc.InnerXml);
            string keys = (string) config["keys"];

            SimpleFileWriter fw = new SimpleFileWriter("config");
            fw.Open();
            fw.Close();
        }

        static void RunService()
        {
            RelayController relay = new RelayController();
            SyslogPacket p = new SyslogPacket();
            p.LocalEndPoint = new IPEndPoint(IPAddress.Loopback, 10);
            p.RemoteEndPoint = new IPEndPoint(IPAddress.Loopback, 0);
            p.PacketData = SyslogMessage.Parse("<23>Sep  6 07:58:08 gw PP[01] Rejected at IN(200021) filter: TCP 219.162.218.29:1917 > 219.163.56.26:135", "219.163.56.25").ToByteArray();
            p.ReceivedDateTime = DateTime.Parse("2002/01/01");

            ListenerController listen = new ListenerController();

            for (int i = 0; i < 10; i++)
            {
                SyslogPacket packet = listen.GetPacket(2000);

                if (packet != null)
                {
                    relay.Relay(packet);
                }

                Thread.Sleep(0);
            }

            listen.Close();
            relay.Close();
        }
/*
        static void XmlRead()
        {
            XmlUrlResolver Resolver = new XmlUrlResolver();
            // ݂̃AZu Evidence 𗘗pURIQƂ
            XmlSecureResolver sResolver = new XmlSecureResolver(Resolver, Assembly.GetExecutingAssembly().Evidence);

            XmlTextReader xr = new XmlTextReader(DefaultSetting.ConfigLocation);
            xr.Normalization = true;

            XmlValidatingReader Validation = new XmlValidatingReader(xr);
            Validation.ValidationType = ValidationType.Schema;
            // URI
            Validation.XmlResolver = sResolver;
            // ftHg̃XL[}P[VXL[}擾
            Validation.Schemas.Add(DefaultSetting.SchemaNamespace, DefaultSetting.SchemaLocation);
            Validation.ValidationEventHandler += new ValidationEventHandler(OnValidation);

            XmlDocument doc = new XmlDocument();
            doc.Load(Validation);
            Validation.Close();

            // XPath Ƀl[Xy[X֘At
            XmlNamespaceManager nsManager = new XmlNamespaceManager(doc.NameTable);
            // ftHgOԂݒ
            nsManager.AddNamespace(String.Empty, DefaultSetting.SchemaNamespace);
            // XPath pɃvtBbNXtOԂݒ
            nsManager.AddNamespace("cf", nsManager.DefaultNamespace);
            

            XmlNodeList AppSettingList = doc.SelectNodes("/cf:syslogConfig/cf:appSettings/cf:add", nsManager);

            XmlAttribute attr = (XmlAttribute) doc.SelectSingleNode("/cf:syslogConfig/cf:appSettings/@defaultEncoding", nsManager);
            Console.WriteLine(attr.Value);
            XmlAttribute attr2 = (XmlAttribute) doc.SelectSingleNode("/cf:syslogConfig/cf:appSettings/@defaultEncoding", nsManager).Clone();
            attr.Value = "shift-jis";
            Console.WriteLine(attr.Value);
            Console.WriteLine(attr2.Value);

            Console.ReadLine();
        }
*/
        static void Assemblies()
        {
            Assembly asm = Assembly.GetAssembly(typeof(StreamReader));
            Console.WriteLine(asm.ToString());

            AssemblyEntry entry = new AssemblyEntry();
            entry.Culture = "";
            Console.WriteLine(asm.GetName().Name);
            Console.WriteLine(asm.GetName().FullName);
            
            AssemblyName AssemblyInfo = new AssemblyName();
            AssemblyInfo.Name = "Microsoft.DirectX";
            AssemblyInfo.CultureInfo = CultureInfo.InvariantCulture;
            AssemblyInfo.SetPublicKeyToken(null);
            AssemblyInfo.Version = new Version("1.0");
            Console.WriteLine(AssemblyInfo.ToString());

            Console.ReadLine();
        }

        static void message()
        {
            SyslogMessage msg = SyslogMessage.Parse("<23>Sep  6 07:58:08 gw PP[01] Rejected at IN(200021) filter: TCP 219.162.218.29:1917 > 219.163.56.26:135", "219.163.56.25");
            Console.WriteLine(msg.ToString());
            Console.WriteLine(msg.Severity);
            object obj = ((ICloneable) msg).Clone();
            Console.WriteLine(obj.ToString());

            SyslogInfo info = new SyslogInfo();
            info.LocalEndPoint = new IPEndPoint(IPAddress.IPv6Any, 513);
            SyslogInfo info2 = (SyslogInfo) info.Clone();
            info2.LocalEndPoint.Address = null;
            Console.WriteLine(info.LocalEndPoint.Address.ToString());

            Console.ReadLine();
        }

        static void RegexPattern()
        {
            // ftHg RegexOptions ̒lw肷
            const RegexOptions RegexOptionGroup =
                      RegexOptions.CultureInvariant | RegexOptions.ExplicitCapture | RegexOptions.IgnorePatternWhitespace | RegexOptions.Singleline;

            #region Dx K\p^[
            //  < Ŏn܂擪 0 ̏ꍇ͌㑱ɐ 3 ̐lōŌオ > ̏ꍇɃ}b`
            const string PriorityRegexPattern = @"
                \A<                                     # ̐擪 < 
                    (?<PRI>                             # Dx PRI ɃLv`
                        (?!0[0-9])                      # 擪 0 tƂ͂Ȃ
                        ([0-9]{1,2}|1[0-8][0-9]|19[01]) # 3̐ : ő 191 ܂
                    )
                >                                       # Ō > ";
            #endregion

            #region ^CX^v K\p^[
            const string TimeStampRegexPattern = @"
                (?=[JFMASOND])                                          # 擪̖Öꕔ̏ꍇ
                (?<TimeStamp>                                           # ^CX^v TimeStamp ɃLv`
                    (Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)   # ̖Öv
                    \                                                   # Xy[X1
                    (\ [1-9]|[12][0-9]|3[01])                           # 131܂ : ꌅ̏ꍇ͐擪ɃXy[X1t
                    \                                                   # Xy[X1
                    ([01][0-9]|2[0-3]):[0-5][0-9]:[0-5][0-9]            #  : 00:00:00  23:59:59 ܂
                )
";
            #endregion

            #region zXg K\p^[
            const string HostAddressPattern = @"
                (?<Host>                                                        # zXg Host ɃLv`
                    (?=[a-zA-Z0-9:])                                            # 擪zXgɎg镶//IPv6ȗL:̏ꍇ
                    (                                                           # zXg/IPv4AhX/IPv6AhX̂ꂩ}b`
                        ([a-zA-z]([-a-zA-Z0-9]{0,61}[a-zA-Z0-9])?)                            # zXg: 擪͉pňȍ~͉p/63ȉ
                    |
                        (22[0-3]|2[01][0-9]|10[0-9]|1?[0-9][0-9]|[1-9])         # IPv4AhX: NXC(223.*)ȉƃ}b`
                        (                                                       #               擪0̏ꍇ̓}b`Ȃ
                            \.                                                  #               .ŋ؂
                            (25[0-5]|2[0-4][0-9]|10[0-9]|1?[1-9][0-9]|[1-9])    #               1255̊Ԃ̐l
                        ){3}                                                    #               3JԂ
                    |
                        ([:.a-fA-F0-9]{2,39})                                   # IPv6AhX: ȈՃ}b`/ׂĂɃ}b`
                    )
                )
";
            #endregion

            #region bZ[W{ K\p^[
            const string MessagePattern = @"
                (?>
                    (?<MSG>             # bZ[W MSG ɃLv`
                        \P{Cn}*         # 蓖ăR[hȊÔׂĂƃ}b`
                    )
                )\z                     # ̖܂Ń}b`";
            #endregion

            #region SyslogpPbg K\p^[
            string SyslogPattern = @"
                (?>
                    (                                       # LPRIwb_Ȃꍇ" +
                        PriorityRegexPattern + @"
                        (?>
                            (                               # Lȃ^CX^vȂꍇ" +
                                TimeStampRegexPattern + @"
                                \                           # ^CX^vƃzXg̊ԂɃXy[X1
                                (                           # LȃzXgȂꍇ" +
                                    HostAddressPattern + @"
                                \                           # zXĝƂɃXy[X1
                                )?
                            )?
                        )
                    )?
                )" + MessagePattern + @"                    # ׂ̑ĂbZ[WƂă}b`";
            #endregion

            const string Log = "<2>Jun  3 23:54:01 hostname TAG[test]: `I";
            //const string PriorityRegexPattern = @"\A<(?<PRI>(?!0[0-9])[0-9]{1,3})>";
            
            // ̖O
            //const string MonthPattern = @"(?=[JFMASOND])(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)";
            //  - Mmm HH:mm:ss
            //const string DateTimePattern = @"(\ [1-9]|[12][0-9]|3[01])\ ([01][0-9]|2[0-3]):[0-5][0-9]:[0-5][0-9]";
            // (?<=^<000>)(Jan|Feb)  1 23:59:00(?!= ) - <000>Jan  1 23:59:00
            //string TimeStampRegexPattern = String.Format(@"(?<={0}>){1}\ {2}(?= )", PriorityRegexPattern, MonthPattern, DateTimePattern);
            //string HostPattern = String.Format(@"{0}[A-Za-z0-9\:\-\.]+(?= )", TimeStampRegexPattern);

            Regex PRIRegex = new Regex(SyslogPattern, RegexOptionGroup);
            //Regex TimeStampRegex = new Regex(TimeStampRegexPattern, RegexOptionGroup);
            //Regex HostRegex = new Regex(HostPattern, RegexOptionGroup);
            // TAG: ABNF p̂
            Regex MSGRegex = new Regex(@"^(?>(?<TAG>[0-9a-zA-Z]{0,32}))(?<CONTENT>\P{Cn}*)", RegexOptionGroup);

            SyslogMessage msg = SyslogMessage.Parse(Log);

            Console.WriteLine(PRIRegex.Match(Log).Value);
            Console.WriteLine("PRI: " + PRIRegex.Match(Log).Groups["PRI"].Value);
            Console.WriteLine("TME: " + PRIRegex.Match(Log).Groups["TimeStamp"].Value);
            Console.WriteLine("HST: " + PRIRegex.Match(Log).Groups["Host"].Value);
            Console.WriteLine("MSG: " + PRIRegex.Match(Log).Groups["TAG"].Value);
            Console.WriteLine(MSGRegex.Match(PRIRegex.Match(Log).Groups["MSG"].Value).Groups["TAG"]);

            Console.ReadLine();
        }

        static void MutexWait()
        {
            WaitEvent.Reset();

            AsyncInvoke.AsyncDynamicInvoke(new AsyncHello(Hello), null);

            for (int i = 0; i < 10; i++)
            {
                lock (Console.Out)
                    Console.Write(".");

                Thread.Sleep(100);
            }

            WaitEvent.Set();

            Thread.Sleep(1500);
        }

        static void Hello()
        {
            for (int i = 0; i < 10; i++)
            {
                lock (Console.Out)
                    Console.WriteLine("Hello!");

                Thread.Sleep(100);
            }

            WaitEvent.Set();
        }

        static void Socket()
        {/*
            Console.WriteLine(DateTime.Now.ToString("yyyy/MM/dd hh:mm:ss.fffffff"));

            ISyslogListener listen = (ISyslogListener) new UDPListener();
            listen.PacketReceived += new ReceivedEventHandler(listen_Received);
            listen.Listen();
            UdpClient u = new UdpClient(0, AddressFamily.InterNetworkV6);
            byte[] d = Encoding.GetEncoding("Shift_JIS").GetBytes("eXg.");
            u.Send(d, d.Length, new IPEndPoint(IPAddress.Parse("2001:218:49c:0:203:47ff:fefe:5bdd"), 514));
            u.Send(d, d.Length, new IPEndPoint(IPAddress.Parse("219.163.56.28"), 514));
            u.Send(d, d.Length, new IPEndPoint(IPAddress.Parse("219.163.56.28"), 514));
            u.Send(d, d.Length, new IPEndPoint(IPAddress.Parse("219.163.56.28"), 514));
            u.Send(d, d.Length, new IPEndPoint(IPAddress.Parse("219.163.56.28"), 514));
            u.Send(d, d.Length, new IPEndPoint(IPAddress.Parse("219.163.56.28"), 514));
            u.Close();
            
            Console.ReadLine();

            listen.Close();

            return;*/

            IPEndPoint local = new IPEndPoint(IPAddress.IPv6Any, 50000);
            Socket socket = new Socket(AddressFamily.InterNetworkV6, SocketType.Dgram, ProtocolType.Udp);
            socket.Bind(local);
            ReceiveDgram state = new ReceiveDgram();
            state.Socket = socket;
            socket.BeginReceiveFrom(state.buffer, 0, state.buffer.Length, SocketFlags.None, ref state.SrcHost, new AsyncCallback(SocketTester.ReceiveCallback), state);

            IPEndPoint local2 = new IPEndPoint(IPAddress.IPv6Loopback, 50000);
            Socket socket2 = new Socket(AddressFamily.InterNetworkV6, SocketType.Dgram, ProtocolType.Udp);
            socket2.Bind(local2);
            ReceiveDgram state2 = new ReceiveDgram();
            state2.Socket = socket2;
            socket2.BeginReceiveFrom(state2.buffer, 0, state2.buffer.Length, SocketFlags.None, ref state2.SrcHost, new AsyncCallback(SocketTester.ReceiveCallback), state2);


            UdpClient udp = new UdpClient(0, AddressFamily.InterNetworkV6);
            try
            {
                // 65535 - 28 @ IPv4 - wb_܂
                // 65535 -  8 @ IPv6 - wb_O
                //udp.Send(new byte[65535 - 28], 65535 - 28, new IPEndPoint(IPAddress.Loopback, 50002));
                udp.Send(Encoding.Unicode.GetBytes("Socket 2"), Encoding.Unicode.GetBytes("Socket 2").Length, new IPEndPoint(IPAddress.IPv6Loopback, 50002));
            }
            catch (SocketException e)
            {
                Console.WriteLine(e.ErrorCode.ToString());
                Console.WriteLine(e.ToString());
            }

            for (int i = 0; i < 10; i++)
            {
                byte[] datagram = Encoding.Unicode.GetBytes("Test!" + i.ToString());
                udp.Send(datagram, datagram.Length, new IPEndPoint(IPAddress.IPv6Loopback, 50000));

                //System.Threading.Thread.Sleep(0);

                lock (ReceiveQueue.SyncRoot)
                {
                    if (ReceiveQueue.Count > 0)
                        Console.WriteLine(ReceiveQueue.Dequeue().ToString());
                    else
                        Console.WriteLine("None");
                }
            }

            //IPEndPoint srcHost = new IPEndPoint(IPAddress.Any, 0);
            //byte[] receiveData = udp.Receive(ref srcHost);
            //Console.WriteLine(Encoding.Unicode.GetString(receiveData));
            //receiveData = udp.Receive(ref srcHost);
            //Console.WriteLine(Encoding.Unicode.GetString(receiveData));
            
            udp.Close();

            Console.WriteLine("Shutdown...");
            Console.ReadLine();
            
            socket2.Close();

            socket.Shutdown(SocketShutdown.Both);
            socket.Close();
		}

        static void ReceiveCallback(IAsyncResult ar)
        {
            ReceiveDgram state = (ReceiveDgram) ar.AsyncState;
            Socket socket = state.Socket;
            EndPoint src = (EndPoint) new IPEndPoint(IPAddress.IPv6Any, 0);
            
            int read = 0;
            try
            {
                read = socket.EndReceiveFrom(ar, ref src);
            }
            catch (SocketException e)
            {
                lock (Console.Out)
                Console.WriteLine(e.ToString());
            }
            
            if (read > 0)
            {
                lock (Console.Out)
                {
                    Console.WriteLine(Encoding.Unicode.GetString(state.buffer, 0, read));
                    Console.Out.Flush();
                }

                Queue SyncQueue = Queue.Synchronized(ReceiveQueue);
                SyncQueue.Enqueue(Encoding.Unicode.GetString(state.buffer, 0, read));
                SyncQueue.Enqueue(((IPEndPoint) src).ToString());

                socket.BeginReceiveFrom(state.buffer, 0, 1024, SocketFlags.None, ref state.SrcHost, new AsyncCallback(SocketTester.ReceiveCallback), state);
            }
        }

        private static bool listen_Received(object sender, ReceivedEventArgs e)
        {
            lock (Console.Out)
                Console.WriteLine(e.Packet.GetPacketString());

            return false;
        }

        private static void OnValidation(object sender, ValidationEventArgs e)
        {
            Console.WriteLine(e.Message);
        }
    }

    class ReceiveDgram
    {
        public byte[] buffer = new byte[Int16.MaxValue * 100];
        public EndPoint SrcHost = (EndPoint) new IPEndPoint(IPAddress.IPv6Any, 0);
        public Socket Socket = null;
    }
}
